/*
 * Log.java
 *
 * Created on 13 ottobre 2007, 22.56
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.cartago.examples.roomsworld;


import alice.cartago.*;

import java.util.LinkedList;

/**
 *
 * @author michelepiunti
 */

@ARTIFACT_MANUAL(

)
public class Log extends Artifact {
    
    private String name;
    private location loc;
    
    private LinkedList<String> notes;
    
    @OBSPROPERTY int lastnote;
    
    /** Creates a new instance of Log */
    public Log() {
    }
    
    
    /** Creates a new instance of Log */
    public Log(String n, location l) {
        name=n;
        loc=l;
    }
    
    /** Creates a new instance of Log */
    public Log(String n, double x, double y) {
        name=n;
        loc= new location(x,y);
    }
    
    @OPERATION void init(String n, location l){
          name=n;
          loc= l;   
          notes = new LinkedList<String>();
          //initialize
          notes.add("000000");
    }
    
    
    @OPERATION void putNote( Object timestamp ){
        notes.addLast( ""+timestamp);
        lastnote = new Integer(""+timestamp).intValue();
        log(name + " UPDATED his PROPERTY - now has the note: " + lastnote );
        //signal("newNote"+agname);
    }
    
    @OPERATION/*(guard="noteAvailable")*/ void readLastNote(){
        
        if(notes.size()>0){
        	Integer lastN = new Integer(notes.getLast());
        	log("try to read in: " + name + " where lastnote is:" + lastN );
        	signal("last_note", lastN );
        }
            
        else signal("noteNOTavailable");
    }
    
    @OPERATION/*(guard="noteAvailable")*/ void readNotes(String timestamp){
        log("try to read: in ch" + name );
        if(notes.getLast()!=null)
            signal("noteavailable", notes.getLast());
        else signal("noteNOTavailable");
    }
    
    
    @GUARD boolean noteAvailable(){
        return (notes.size() > 0); 
    }
    
    @OPERATION void removeNote(String agname){
        log("REMOVE on " + name + " - with" + notes.size() + "notes");
        notes.remove(agname);
        log("now " + name + " has " + notes.size() + "notes");
    }
    
    
    
    @OPERATION void getInfo(){
        String info = "Artifact name :" +name 
        + "\n" + loc 
        + "\n system id: " + getId();
        
        signal("artifactInfo",info); 
    }
    
    
}


/*
public class Log extends Artifact { 
	private LinkedList<String> notes; 
    private String name;
    private location loc;
	
	@OBSPROPERTY int lastnote; 
	
	@OPERATION void init(String n, location l){ 
		name=n; loc= l; 
		notes = new LinkedList<String>(); 
	} 
	
	@OPERATION void putNote( Object ts ){ 
		notes.addLast(ts.toString()); 
		lastnote = ((Integer)ts).intValue(); 
	} 
} 
*/
