/*
 * LogRetail.java
 *
 * Created on 6 6 08
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */
package alice.cartago.examples.roomsworld;

import alice.cartago.*;


@ARTIFACT_MANUAL(

)
public class LogRetail extends Artifact {
    
    private String name;
    private location loc;     
    private int nticks; 
    
    @OBSPROPERTY int flag;
    @OBSPROPERTY int evaporationTime;   //threshold
    
    
    @OPERATION void init(String n, location l){
          name=n;
          loc= l;   
          flag=0;
          nticks=0;
          evaporationTime=12000;
    }
       
    @OPERATION void switchFlag(int f){
       updateProperty("flag", f);
       signal("flag", flag);
       try {
			nextStep("tick");
	   } catch (Exception ex){
			ex.printStackTrace();
	   }
    }
    
    @OPSTEP(tguard=200) void tick(){
		
		if (nticks<evaporationTime){
			nticks+=200;	
			//log(" TICK :"+nticks);
			try {
				nextStep("tick");
			} catch (Exception ex){
				ex.printStackTrace();
			}
		} else {
			nticks=0;
			updateProperty("flag", 0);
			log("\n\n"+name+": *** FLAG is EVAPORATED ("+evaporationTime+")*** \n\n");
		}
	}
    
    @OPERATION void switchOffFlag(){
    	updateProperty("flag", 0);
    }
    
    
    @OPERATION void changeEvaporationTime(int ev){
    	updateProperty("evaporationTime", ev);
    }
    
    
    @OPERATION void getInfo(){
        String info = "Artifact Name :" +name 
        + "\n" + loc 
        + "\n system id: " + getId();
        
        signal("artifactInfo",info); 
    }
    
}
