/*
 * Watch.java
 *
 * Created on 24 ottobre 2007, 23.34
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.cartago.examples.roomsworld;



import alice.cartago.*;

/**
 *
 * @author michelepiunti
 */
@ARTIFACT_MANUAL(
		outports = {
			@OUTPORT(name = "link")
			}
)
public class Watch extends Artifact{
    
	@OBSPROPERTY long sim_time;
	
    private final long exp_length = 303;
    
    /** Creates a new instance of Watch */
    public Watch() {
    }
    
    @OPERATION void init(){
      sim_time=0;
    }
    
    @OPERATION void tickTime() {
        ++sim_time;
        try {
           // propagate sim-time to environment 
           // (and then to envGUI)
              outSignal("link", new Op("setSimTimE2", sim_time ));          
           if(sim_time==exp_length) {
        	   log("exp_end!!");
        	   signal("exp_end");
           }
    
        }catch(Exception ex){
            log("linkop set time failed");
        }
    }
    
    @OPERATION void whatTime() {
        //log("time is: "+ sim_time);
        signal("time", sim_time);
    }
    
    
}
