/*
 * agensFaber.java
 *
 * Created on 4 ottobre 2007, 17.08
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */


package alice.cartago.examples.roomsworld;

import alice.cartago.*;
import java.util.*;

//import java.awt.event.*;

//import alice.cartago.*;
import alice.cartago.util.*;


//import java.net.MalformedURLException;
//import java.rmi.server.UnicastRemoteObject;
//import java.rmi.RMISecurityManager;
//import java.rmi.Naming;
//import java.rmi.RemoteException;



/**
 *
 * @author michelepiunti
 */
public class agensFaber extends Agent {
    
    private HashMap<String, location> logs;
    private ArtifactId idlog;
    private String ws;
    /**
     * define the Number of ROOMS
     **/
    private int N_ROOMS;
    
    
    public agensFaber(String name, String env) throws CartagoException {
       super(name);
       ws = env;
       logs = new  HashMap<String, location>();
       N_ROOMS = 8;
    }


    public void run() {
        log("agensFaber started");
        
        try {
            joinWorkspace(ws);
            String path = "alice.cartago.examples.roomsworld.";
            ArtifactId idenv = makeArtifact("environment", path+"environment",
                    new ArtifactConfig(N_ROOMS));           
            log("created env.");
            
            //CartagoGUISystem.init(env);
            ArtifactId idgui = makeArtifact("envGUI", path+"envGUI");
            log("created gui.");
            
            ArtifactId idconsole = makeArtifact("io", path+"roomsConsole"); 
                   //  new ArtifactConfig());
            log("created console.");
            
            ArtifactId idwatch = makeArtifact("watch", path+"Watch",
                    new ArtifactConfig());
            log("created Watch.");
            
            ArtifactId idstats = makeArtifact("stats", path+"stats",
                    new ArtifactConfig());
            log("created stats controller.");

            // link artifacts
            linkArtifacts(idenv, "link",idgui);
            linkArtifacts(idconsole, "link",idgui);
            linkArtifacts(idenv, "link2",idstats);
            linkArtifacts(idwatch, "link",idenv);
            
            // set environment Layout
            use(idenv, new Op("setLayout"));
            
                        
            // create checklists
            String logstr = "";
            LinkedList<location> logloc = new LinkedList<location>();
            if(N_ROOMS==8){                 // 8 rooms
                logloc.addLast( new location(0.375, 0.75));            
                logloc.addLast( new location(0.625, 0.75));
                logloc.addLast( new location(0.75, 0.625));
                logloc.addLast( new location(0.75, 0.375));
                logloc.addLast( new location(0.625, 0.25));
                logloc.addLast( new location(0.375, 0.25));
                logloc.addLast( new location(0.25, 0.375));
                logloc.addLast( new location(0.25, 0.625));
            }else if(N_ROOMS==4){           // 4 rooms   
            	logloc.addLast( new location(0.25, 0.5));            
            	logloc.addLast( new location(0.5, 0.75));
            	logloc.addLast( new location(0.75, 0.5));
            	logloc.addLast( new location(0.5, 0.25));
            }
            for(int i=0; i<N_ROOMS; i++){
                logstr = "log"+(i+1);
                idlog = makeArtifact(logstr, path+"Log", 
                               new ArtifactConfig(logstr,logloc.get(i)));
                logs.put(logstr, logloc.get(i));              
            }
           
            // dispose logs
            use(idenv, new Op("setChecklists", logs));
            
            SensorId sid = linkDefaultSensor();
            use(idlog, new Op("getInfo"), sid);            
            Perception p = sense(sid, "artifactInfo");
            log("created: " + p.getContent(0));

           
        }catch (Exception ex){
        	ex.printStackTrace();
        }
        
        log("created world.");
    }
}