/*
 * AgentEnv.java
 *
 * Created on 9 ottobre 2007, 20.14
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.cartago.examples.roomsworld;

import alice.cartago.*;
import alice.cartago.util.*;
/**
 *
 * @author michelepiunti
 */
public class agentExpHandler extends Agent {
    
    private ArtifactId idwatch,idenv,idstats;
    private SensorId sid;
    private String ws;
    
    /**
     * Creates a new instance of AgentEnv
     */
    public agentExpHandler (String name, String env) throws CartagoException {
        super(name);
        ws=env;
        
    }
    
    public void run() {
        try {
            joinWorkspace(ws);
            log("Agent Experiment Handler joined "+ws );
            sid = linkDefaultSensor();            
            sleep(5000);
            idwatch = lookupArtifact("watch");
            idstats = lookupArtifact("stats"); 
            idenv = lookupArtifact("environment");

            log("focusing the Watch ..." );
            focus(idwatch,sid);
            sense(sid, "exp_end", java.lang.Integer.MAX_VALUE);
            
            use(idenv,new Op("getStats"),sid);
            Perception p = sense(sid,"stats_available");
            String result = p.getContent(0).toString();
            
            log("\n\nRESULT:\n*****"+result +"*******\n\n\n");
            
            // use the artifact "stats" to collect 
            // the experiment stats in a file
            use(idstats, new Op("storeStats"), sid); 
            
        }catch(Exception e) {
        	log("agent Exp Handler catch an exception: ");
            e.printStackTrace();
        }

            
    }
    
}
