/*
 * AgentInfo.java
 *
 * Created on 7 ottobre 2007, 18.26
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.cartago.examples.roomsworld;

import java.util.*;
import java.io.FileOutputStream;

/**
 *
 * @author michelepiunti
 */
public class agentInfo {
    
    private String name;
    private location loc;
    //store temporal effectiveness (time, effectiveness)
    private LinkedHashMap effectiveness;
    
    //stats
    private HashMap pickedTrashes;
    
    /** Creates a new instance of AgentInfo */
    public agentInfo() {
        this.loc = new location(.5,.5);
        this.pickedTrashes = new HashMap();
        this.effectiveness = new LinkedHashMap();
    }
    
    /** Creates a new instance of AgentInfo */
    public agentInfo(String name) {
        this.name = name;
        this.loc = new location(.5,.5);
        this.pickedTrashes = new HashMap();
        this.effectiveness = new LinkedHashMap();
    }
    
    
    public void setLocation(location l) {
        loc = l;
    }
    
    public location getLocation() {
        return loc;
    }
    
    public String getName() {
        return name;
    }
    
    public int getPickedTrashes() {
       return pickedTrashes.size();
    }
    
    public void incPickedTrashes(long time, trash obj) {
       pickedTrashes.put(time, obj);
    }
    
    //stats
    
    public void storeEffectiveness(long st, long totTr){
        double eff = new Double(pickedTrashes.size()).doubleValue() / totTr;
        effectiveness.put(st, eff );
    }
    
    
    public LinkedHashMap getEffectiveness(){
        return effectiveness;
    }
    
    
    
    
//    /**
//     * @return the registered storic effectiveness ArrayList
//     */
//    public double[] getStoricEffectivenessArray() {
//            double[] ret = new double[getEffectivenessList().size()];
//            for (int i = 0; i < agentStats.getEffectivenessList().size(); i++)
//                    ret[i] = agentStats.getEffectivenessList().get(i);
//
//            return ret;
//    }
    
}
