/*
 * blackboard.java
 *
 * Created on 15 ottobre 2007, 21.32
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.cartago.examples.roomsworld;

/**
 *
 * @author michelepiunti
 */


import alice.cartago.*;

import java.util.HashMap;

/**
 *
 * @author michelepiunti
 */
public class blackboard extends Artifact {
    
    private String name;
    
    private HashMap<String,location> notes;
    
    /** Creates a new instance of Log */
    public blackboard() {
    }
    
    
    /** Creates a new instance of Log */
    public blackboard(String n) {
        name=n;
    }

    
    @OPERATION void init(String artname){
          name=artname;  
          notes = new HashMap<String,location>();
    }
    
    
    @OPERATION void post(String name, location loc){
        notes.put(name, loc);
        log(name + "now has the note:" + name + "at loc:" +loc);
        signal("newNote");
    }
    
    @OPERATION/*(guard="noteAvailable")*/ void read(){
        signal("note", notes);
    }
    
    
    @GUARD boolean noteAvailable(){
        return notes.size() > 0; 
    }
    
    @OPERATION void removePost(String note){        
        notes.remove(note);
    }
    
    
    
    @OPERATION void getInfo(){
        String info = "Artifact name :" +name 
        + "\n system id: " + getId();
        
        signal("artifactInfo",info); 
    }
    
    
}
