/*
 * room.java
 *
 * Created on 4 ottobre 2007, 13.17
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.cartago.examples.roomsworld;



import java.util.*;

/**
 *  A room is defined by north-west and south-east corner locations 
 *  and by its center
 * @author michelepiunti
 */
public class room {
    
    private final double x1,y1,x2,y2;
    private final location center;
    private int room_number;
    
    /** contained trashes  */
    private ArrayList<trash> trashes;
    /** walls */
    private ArrayList<wall> walls;
    
//    /** Creates a new instance of room */
//    public room() {
//        trashes = new ArrayList<trash>();
//    }
    
    /** 
     * Creates a new instance of room
     * @param x1,y1,x2,y2 location coordinates
     */
    public room(double xx1, double yy1, double xx2, double yy2) {
        trashes = new ArrayList<trash>();
        x1 = xx1;
        y1 = yy1;
        x2 = xx2;
        y2 = yy2;
        center = new location ((x1+x2)/2, (y1+y2)/2);
        walls = new ArrayList<wall>();
        setwalls();
    }
    
    /**
     * Creates a new instance of room
     * @param n is the room_number in roomsworld
     */
    public room(double xx1, double yy1, double xx2, double yy2, int n) {
        trashes = new ArrayList<trash>();
        x1 = xx1;
        y1 = yy1;
        x2 = xx2;
        y2 = yy2;
        center = new location ((x1+x2)/2, (y1+y2)/2);
        room_number = n; 
        walls = new ArrayList<wall>();
        setwalls();
    }
    
    public trash addTrash()  {
        trash tr = new trash(getInRoomLocation());
        if( trashes.add(tr) )  {
            return tr;
        }
        else
            return null;
       
    }
    
    
    public trash addTrash(trash tr)  {
        if( trashes.add(tr) )  {
             return tr;
        }
        else
            return null;
       
    }
    
    public boolean delTrash(trash tr)  {
        for(int i=0; i<trashes.size(); i++) {
            if(trashes.get(i).getLocation().isEqual(tr.getLocation()))  {
                trashes.remove(i);     
                return true;
            }       
        }
        return false;
    }
    
    
    public int getNTrashes()  {
      return trashes.size();
    }
    
    public ArrayList<trash> getTrashes()  {
      return trashes;
    }
    
    public location getInRoomLocation() {
        
        Random r = new Random(System.currentTimeMillis());
        
        double dx = r.nextDouble() /8;
        double lx = (r.nextDouble()<0.5? center.getX() + dx: center.getX() - dx);
        double dy = r.nextDouble()/8;
        double ly = (r.nextDouble()<0.5? center.getY() + dy: center.getX() - dy);
        location loc = new location(lx,ly);
        if(isInRoomLocation(loc)) return loc  ;
        else return getInRoomLocation();
    }
    
    private boolean isInRoomLocation(location loc) {
        return ((loc.x<x2)&&(loc.x>x1)&&(loc.y<y1)&&(loc.y>y2) );        
    }
    
    private void setwalls(){
      walls.add(new wall(x1,y1,x2,y1));
      walls.add(new wall(x2,y1,x2,y2));
      walls.add(new wall(x2,y2,x1,y2));
      walls.add(new wall(x1,y2,x1,y1));
    }
    
    public ArrayList<wall> getWalls(){
        return walls;
    }
    
    public int getNo(){
        return room_number;
    }
    
    
}
