package alice.cartago.examples.roomsworld;

import java.util.LinkedHashMap;
import java.util.Iterator;
import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;

import alice.cartago.Artifact;
import alice.cartago.OPERATION;
import alice.cartago.OPSTEP;

public class stats extends Artifact {

	 LinkedHashMap<Integer,Integer> totTrashes;
	 LinkedHashMap<Integer,Double> totEffectiveness;
	 LinkedHashMap<Integer,Double> totCosts;
	 String expType = "4_stig_AGENTS_ev12";
	 int totCost,totTrash;

	
    @OPERATION void init(){
    	
        totTrashes = new LinkedHashMap<Integer,Integer>();
        totEffectiveness = new LinkedHashMap<Integer,Double>();
        totCosts = new LinkedHashMap<Integer,Double>();
        totCost = 0;
        totTrash = 0;
        
      }
    
    @OPERATION void updateTotTrashes(long t, int tr){
    	//log("updating trashes stats ");
    	totTrashes.put(new Integer((int)t), new Integer(tr));
    	totTrash = tr;
    	
    }
    
    @OPERATION void updateEffectiveness(long t, double eff){
    	//log("updating agent effectiveness stats ");
    	totEffectiveness.put(new Integer((int)t), new Double(eff));
    }
    
    @OPERATION void updateCosts(long t){
        totCosts.put(new Integer((int)t), new Double((double)totTrash/(double)totCost));
    }
    
    @OPERATION void storeStats(){
    	log("global effectiveness has values: ");
    	Iterator<Double> iter = totEffectiveness.values().iterator();    	
    	while(iter.hasNext()){
    		log(" "+  iter.next().doubleValue() );
    		
    	}
    	
    	log("total picked has progress:");

    	nextStep("fileStep");
    	
    }//storeStats
    
   @OPERATION void incCost(int Nc){
    	totCost+=Nc;
        
   }//incCost
    

   @OPSTEP void  fileStep()  {
    	Iterator<Double> iter1 = totEffectiveness.values().iterator();  
    	Iterator<Double> iter2 = totCosts.values().iterator();
        String filename = "./ESAW.stats/ESAW_"+expType+".txt";
    	try {
    	    File f = new File(filename);
    	    FileOutputStream fos = new FileOutputStream(f);
            PrintStream out = new PrintStream(fos);
            out.println("log of CUMULATIVE effectiveness (for ALL AGENTS) in exp : " + expType );
            out.println("");
            out.println("");
            out.println("tot trash: "+totTrash);
            out.println("effectiveness: totTr/totTime"); 

            out.println("");
            while(iter1.hasNext()){
                    out.println(" "+  iter1.next().doubleValue() );       		
            }
            out.println("");
            out.println("");        	
            out.println("tot cost: " + totCost);
            out.println("costs: totTr/totCosts");
            out.println("");
            while(iter2.hasNext()){
                    out.println(" "+  iter2.next().doubleValue() );       		
            }
            
            out.close();
            fos.close();
            
    	}catch(Exception e){
    		log("fileStep : ERROR in writing file");
    		e.printStackTrace();
    	}	
    }//fileStep
 
}
