/*
 * CollectEvents.java
 *
 * Created on 18 giugno 2008, 13.27
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import java.util.LinkedList;

import jadex.runtime.IInternalEvent;

import alice.c4jadex.bridge.AgentContext;
import alice.cartago.ICartagoContext;
import alice.cartago.Perception;
import alice.cartago.Tuple;

/**
 *    CollectEvents
 * @author Michele Piunti
 */
public class CollectEvents extends cartago_action {
    
	private  LinkedList<alice.cartago.Event> cartagoEventQueue;
	
	String agentName;
    AgentContext actx;
    
    /** Creates a new instance of CollectEvents */
    public CollectEvents() {
        agentName = getAgentName();  
        
    }
    
    public void body() {
       actx = getContext(agentName);	
       if(actx!=null) {

    	startAtomic();
    	cartagoEventQueue = actx.getEventQueue();
    	synchronized(cartagoEventQueue){
			for (alice.cartago.Event ev: cartagoEventQueue){    	
			
			  IInternalEvent event = createInternalEvent("artifact_event");
              event.getParameter("label").setValue(ev.getLabel());
              
              if(ev.getContents().length>0)
                event.getParameter("content").setValue((Tuple)ev.getContent());
              
              //log(" Authomatically retrieved an artifact event with label:"+ev.getLabel());
              //log(" Now Dispatching Jadex IEvent: " + event.getName() + " label: " +   event.getParameter("label").getValue() );
              
              //log("TRANLSATING AN EVENT : " + 
    			//ev.toString() +"\n IN A JADEX INTERNAL EVENT: " + event); 
              			
              dispatchInternalEvent(event);

			}
			actx.clearEvents();
		}
        endAtomic();
        
      }//if actx != null
    }
    
    //public void postNewEventInSensor(SensorId sid, Event ev){}
    
    
}
