/*
 * cartago_action.java
 *
 * Created on 29 novembre 2007, 15.48
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import jadex.model.IMCapability;
import jadex.model.IMEventbase;
import jadex.model.IMInternalEvent;
import jadex.runtime.Plan;
import jadex.runtime.impl.PlanInstanceInfo;
import jadex.runtime.impl.RInternalEvent;
import jadex.runtime.impl.WaitAbstraction;
import jadex.runtime.impl.agenda.ComposedPrecondition;
import jadex.runtime.impl.agenda.IAgendaAction;
import jadex.runtime.impl.agenda.IAgendaActionPrecondition;
import jadex.runtime.impl.agenda.eventprocessing.ScheduleCandidatesAction;
import jadex.runtime.impl.agenda.plans.DefaultPlanActionPrecondition;
import jadex.util.collection.SCollection;

import java.util.List;

import alice.c4jadex.bridge.AgentContext;
import alice.c4jadex.bridge.AgentContextManager;

/**
 *    cartago_action
 * @author Michele Piunti
 */
public class cartago_action extends Plan {
    
    AgentContext actx;
    
    /** Creates a new instance of cartago_action */
    public cartago_action() {        

    }
    
    /**
     * the plan body
     */
    public void body(){
//        try{
//            actx = getContext( getAgentName() ); 
//            if (actx==null){
//	       throw new Exception("Need to join a workspace.");
//            }
//        } catch(Exception ex){
//            ex.printStackTrace();
//        }
        
    }
    
    
   protected  synchronized AgentContextManager getContextManager(){
       AgentContextManager acm = null;        
       try{
            acm = (AgentContextManager)getBeliefbase().getBelief("AgentContextManager").getFact();
            if(acm==null){
                acm = new AgentContextManager(getAgentName());
                getBeliefbase().getBelief("AgentContextManager").setFact(acm);
            }
            
        }catch(Exception e){
            System.out.println("Impossible to find my ContextManager: ");
            e.printStackTrace();
        }
       
       return acm;
   }
           

    
    protected synchronized AgentContext getContext(String name){
        return getContextManager().getCurrentContext();
    }
    
    
    protected void updateContext(AgentContextManager acm){
        getBeliefbase().getBelief("AgentContextManager").setFact(acm);
    }
    
//    protected final AgentContext getContext(String name){
//		return ContextManager.instance().getContext(name).getCurrentContext();
//    }
    
    protected void log(String s){
        System.out.println("["+getAgentName()+"] " + s);
    }
 
    
    /**
	 *  Listener that can suspend/resume threaded plans.
	 */
	public class SyncResultListener
	{
		//-------- attributes --------
		
		/** The result. */
		protected Object result;

		/** The exception. */
		protected Exception exception;
		
		/** Flag if already suspended. */
		protected boolean suspended;
		
		/** Flag if already resumed. */
		protected boolean resumed;
		
		//-------- methods --------
		
		/**
		 *  Called when the result is available.
		 *  @param result The result.
		 */
		public void resultAvailable(final Object result)
		{
			// Might be called from external threads: synchronize with agent.
			getRCapability().getAgent().getInterpreter().invokeLater(new Runnable()
			{
				public void run()
				{
					SyncResultListener.this.result = result;
					if(suspended)
					{
						resume();
					}
				}
			});
		}

		/**
		 *  Called when an exception occurred.
		 *  @param exception The exception.
		 */
		public void exceptionOccurred(final Exception exception)
		{
			// Might be called from external threads: synchronize with agent.
			getRCapability().getAgent().getInterpreter().invokeLater(new Runnable()
			{
				public void run()
				{
					SyncResultListener.this.exception = exception;
					if(suspended)
					{
						resume();
					}
				}
			});
		}
		
		/**
		 *  Wait for the result.
		 *  @return The result.
		 */
		public Object waitForResult()
		{
			getCapability().checkThreadAccess();
			if(!resumed)
			{
				suspend();

				if(!resumed)
				{
					throw new RuntimeException("Suspension was not ended by resume.");
				}
			}
			
			if(exception instanceof RuntimeException)
				throw (RuntimeException)exception;
			else if(exception!=null)
				throw new RuntimeException(exception);
			return result;
		}

		/**
		 *  Suspend the execution of the plan until resume() is called.
		 */
		protected void suspend()
		{
			getCapability().checkThreadAccess();
			if(suspended)
				throw new RuntimeException("suspend() may be called only once.");
			suspended	= true;
			getCapability().checkThreadAccess();
			getRPlan().getPlanExecutor().eventWaitFor(getRPlan(), new WaitAbstraction(getRPlan().getScope()));
		}
		
		/**
		 *  Resume the execution of the plan after the plan has been suspended.
		 */
		protected void resume()
		{
			getCapability().checkThreadAccess();
			if(resumed)
				throw new RuntimeException("resume() may be called only once.");
			resumed = true;

			// Create internal event to dispatch when timeout occurs.
			IMInternalEvent	mevent	= ((IMCapability)getRPlan().getScope().getModelElement())
				.getEventbase().getInternalEvent(IMEventbase.TYPE_TIMEOUT);
			RInternalEvent event = getRPlan().getScope().getEventbase().createInternalEvent(mevent);
			List cands = SCollection.createArrayList();
			cands.add(new PlanInstanceInfo(event, getRPlan()));
			
			IAgendaAction action = new ScheduleCandidatesAction(
				new ComposedPrecondition(
					new IAgendaActionPrecondition()
					{
						public boolean check()
						{
							return !getRPlan().isScheduled();
						}
					},
					new DefaultPlanActionPrecondition(getRPlan())), 
				getRCapability().getAgent(), event, cands);
		
			getRCapability().getAgent().getInterpreter().addAgendaEntry(action, null);
		}
	}
    
}


    

