/*
 * create_workspace.java
 *
 * Created on 20 febbraio 2008, 11.02
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */
package alice.c4jadex.bridge.actions;


import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;
/**
 *    create_workspace
 * @author Michele Piunti
 */
public class create_workspace extends cartago_action {
    
    /** Creates a new instance of create_workspace */
    public create_workspace() {
    }
    
    public void body() {
        String wspName = (String)getParameter("workspace_name").getValue();
        String agentName = getAgentName();  
        AgentContext actx = getContext(agentName);
        ICartagoContext ctx = actx.getContext();     
        
        try {
            ctx.createWorkspace(wspName.toString());
            try {
                    ICartagoContext context = ctx.joinWorkspace(wspName.toString(),agentName);
                    WorkspaceId wspId = context.getWorkspaceId();
                    AgentContext newActx = new AgentContext(agentName,wspId,context);
                    
                    AgentContextManager man = getContextManager();
                    man.register(wspId, newActx);
                    man.setCurrentContext(wspName);
          
            } catch (Exception ex) {
                    log("Error in joining the workspace just created: " + ex.getMessage());
                    //ex.printStackTrace();
                    //throw new Exception("Error in joining the workspace just created" + ex);
            }
                
        } catch (Exception ex) {
                log("Internal action createWorkspace failed: " + ex.getMessage());
                //ex.printStackTrace();
                //throw new Exception("Internal action createWorkspace failed: " + ex);
        }
        }
    
}
