/*
 * join_workspace.java
 *
 * Created on 29 novembre 2007, 14.56
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import alice.cartago.security.*;
import jadex.runtime.*;

/**
 *    join_workspace action join to a Cartago context
 *    if the parameter <i>address</i> is specified, join to remote context via java RMI
 * @author Michele Piunti
 */
public class join_workspace extends cartago_action {
    
    AgentContextManager man;
    
    /** Creates a new instance of join_workspace */
    public join_workspace() {
        
    }    
    /**
     * the plan body
     * 
     */
    public void body(){
        String wspAddress = (String)getParameter("workspace_address").getValue();
        String wspName = (String)getParameter("workspace_name").getValue();
        String roleName = (String)getParameter("role_name").getValue();
        String agentName = getAgentName();
                //(String)getParameter("agent_name").getValue();
        System.out.println(agentName + " is joining to:" + wspName + "  at: " + wspAddress); 
        
        man = getContextManager();
        
        if (wspAddress!=null){

        try {
                        // CartagoService.installNode();
                        ICartagoContext context = null;

                        if (roleName.equals("")){
                                context = CartagoService.joinWorkspace(wspName.toString(),wspAddress.toString(),agentName);
                                
                        } else {
                            String id = (String)getParameter("id").getValue();
                            String pwd = (String)getParameter("pwd").getValue();
                            UserPwdCredential ucred = new UserPwdCredential(id,pwd); 
                           context = CartagoService.joinWorkspace(wspName.toString(),roleName,ucred);
                        }
                        WorkspaceId wspId = context.getWorkspaceId();
                        AgentContext actx = new AgentContext(agentName,wspId,context);
                        
                        man.register(wspId,actx);
                        man.setCurrentContext(wspName);
                        
                        updateContext(man);
                        
                        
        } catch (Exception ex) {
                System.out.println("Internal action join failed: ");
                ex.printStackTrace();
                //throw new Exception("Internal action join failed: " + ex);
        }
        } else {   // Cartago is on the same Node and Virtual Machine
               try {
				// CartagoService.installNode();
                                ICartagoContext context = null;
				
				if (roleName==null){
					context = CartagoService.joinWorkspace(wspName.toString(),agentName);
				} else {
					String id = (String)getParameter("id").getValue();
                                        String pwd = (String)getParameter("pwd").getValue();
                                        UserPwdCredential ucred = new UserPwdCredential(id,pwd); 
                                        context = CartagoService.joinWorkspace(wspName.toString(),roleName,ucred);
				}
				WorkspaceId wspId = context.getWorkspaceId();
				AgentContext actx = new AgentContext(agentName,wspId,context);
				
				man.register(wspId,actx);
				man.setCurrentContext(wspName);
                                
                                updateContext(man);
                                
			} catch (Exception ex) {
                                System.out.println("Internal action join failed: ");
				ex.printStackTrace();
				//throw new Exception("Internal action join failed: " + ex);
			}

        }
        
        System.out.println("["+getAgentName()+"] Joined. current context is: " + man.getCurrentContext()  );
        
    }
}
