/*
 * lookup_artifact.java
 *
 * Created on 29 novembre 2007, 14.55
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    lookup_artifact
 * @author Michele Piunti
 */
public class lookup_artifact extends cartago_action {
   
    /** Creates a new instance of lookup_artifact */
    public lookup_artifact() {
        
    }
    
    /**
     * the plan body
     */
    public void body(){
        
        String agentName = getAgentName();        
        try{
            actx = getContext(agentName); 
            if (actx==null){
	       throw new Exception("Need to join a workspace before looking for Artifacts.");
            }
        } catch(Exception ex){
            ex.printStackTrace();
            return;
        }
        ICartagoContext ctx = actx.getContext();
       

        SensorId sid = null;

        String artifactName = (String)getParameter("artifact_name").getValue();
        ArtifactId id = null;
        String a_id = null;		
        try {
                sid = ctx.linkDefaultSensor();
                ctx.use(ctx.getRegistryId(),new Op("lookupArtifact",artifactName.toString()),sid);
                Perception p = ctx.sense(sid,"lookup_succeeded|lookup_failed");
                if (p.getLabel().equals("lookup_succeeded")){
                        id = (ArtifactId)p.getContent(0);
                        a_id = actx.storeArtifactId(id);
                        //ok =  un.unifies(args[1], new Atom(s_id));
                }
        } catch (Exception ex){
                ex.printStackTrace();
                return;
                //throw new JasonException("lookup failed: "+ex);
        } finally {

        }
        
        if(id!=null) {
            getParameter("aid").setValue(id);
        } else {
            getParameter("aid").setValue(null);
        }
  
    }//body
    
}
