/*
 * make_artifact.java
 *
 * Created on 4 dicembre 2007, 15.01
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    make_artifact
 * @author Michele Piunti
 */
public class make_artifact extends cartago_action {
    
    /** Creates a new instance of make_artifact */
    public make_artifact() {
    }
    
    /**
     * the plan body
     */
    public void body(){
        String agentName = getAgentName();        
        try{
            actx = getContext(agentName); 
            if (actx==null){
	       throw new Exception("Need to join a workspace before creating Artifacts.");
            }
        } catch(Exception ex){
            ex.printStackTrace();
        }
        ICartagoContext ctx = actx.getContext();
       

        SensorId sid = null;

        String artifactName = (String)getParameter("artifact_name").getValue();
        String artifactTemplate = (String)getParameter("artifact_template").getValue();
              
        ArtifactId id = null;
        String a_id = null;		
        try {
                sid = ctx.linkDefaultSensor();
                
                ArtifactConfig aconfig = (ArtifactConfig)getParameter("artifact_config").getValue();
                if(aconfig==null) 
                   ctx.use(ctx.getFactoryId(), new Op("makeArtifact",artifactName , artifactTemplate),sid);
                else
                   ctx.use(ctx.getFactoryId(), new Op("makeArtifact",artifactName , artifactTemplate, aconfig),sid);
   
                Perception p = ctx.sense(sid,"make_succeeded|make_failed");
                if (p.getLabel().equals("make_succeeded")){
                        id = (ArtifactId)p.getContent(0);
                        a_id = actx.storeArtifactId(id);
                }
        } catch (Exception ex){
            log("make artifact action failed with: "+ex.getMessage());  
                //ex.printStackTrace();
                //throw new JasonException("make artifact failed: "+ex);
        } finally {

        }
        
        if(id!=null) {
            getParameter("aid").setValue(id);
        }
    }
    
}
