/*
 * observe_property.java
 *
 * Created on 25 febbraio 2008, 16.51
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    observe_property
 * @author Michele Piunti
 */
public class observe_property extends cartago_action {
    
    ArtifactProperty value = null;
    
    /** Creates a new instance of observe_property */
    public observe_property() {
    }
    
     /**
     * the plan body
     */
    public void body(){
        String agentName = getAgentName();         
        AgentContext actx = getContext(agentName);
        ICartagoContext ctx = actx.getContext();
        
        if (actx==null){
                System.out.println("No agent Context retrieved. Need to join a workspace.");
                return;
        }
        String artifactName = (String)getParameter("artifact_name").getValue();
        ArtifactId  aid = actx.getArtifactId(artifactName);
        if(aid==null){
                System.err.println("[obsreve_property] No Artifact:" +artifactName+ " retrieved in current workspace" );
                return;
        }
            
        String propName = (String)getParameter("property").getValue();
        
        //System.err.println("[obsreve_property] observing " + propName + " on  " + aid );

        try {
             if(propName!=null || !propName.equals("")){

                 value = ctx.observeProperty(aid, propName);
             } else{
                System.err.println("[obsreve_property] Missing required argument 'property'" );
                return;
             }
     
        } catch (Exception ex){
        	System.err.println("[obsreve_property] Error in " +ex.getMessage() );
            ex.printStackTrace();
                //return false;
        } finally {
            
        }       
        // out value
        if(value!=null) {
            //log("[obsreve_property]: "+propName+": has value: " + value.toString());
            getParameter("value").setValue(value);        
        }
        else{
            System.err.println("[obsreve_property] Missing: '" +propName+  "' property" );
            
         }
    }
         
    
}
