/*
 * ObserveCounterPlan.java
 *
 * Created on 19 giugno 2008, 12.16
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.examples;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    ObserveCounterPlan
 * @author Michele Piunti
 */
public class ObserveCounterPlan extends Plan {
    
    String aName,sensorName,filter;
    
    /** Creates a new instance of ObserveCounterPlan */
    public ObserveCounterPlan() {
       aName = "count";
       sensorName = (String)getParameter("sensorName").getValue();
       //filter = (String)getParameter("filter").getValue();
       
       
    }
    
    public void body(){
        log("Hello! going to focus:"+ aName + " with sensor: " + sensorName);
        
        waitFor(1000);
        
        // 1. LOOK FOR ARTIFACT aName
                
        IGoal lookup = createGoal("lookup");
        lookup.getParameter("artifact_name").setValue(aName);                
        dispatchSubgoalAndWait(lookup);
        ArtifactId aid = (ArtifactId)lookup.getParameter("aid").getValue();
        // 1.b create if not exist
        if(aid==null){
            System.out.println("Artifact not found, creating it...");
            String aTemplate = "alice.cartago.examples.basic.Count";
            ArtifactConfig aConfig = new ArtifactConfig();
            IGoal make = createGoal("make");
            make.getParameter("artifact_name").setValue(aName); 
            make.getParameter("artifact_template").setValue(aTemplate); 
            make.getParameter("artifact_config").setValue(aConfig); 
            dispatchSubgoalAndWait(make);
        }else
             log("Artifact: " + aName +" found with id: " + aid);
            
        
        // 2. FOCUS on IT        
        IGoal focus = createGoal("focus");
        focus.getParameter("artifact_name").setValue(aName); 
        focus.getParameter("sensor_name").setValue(sensorName); 
        dispatchSubgoalAndWait(focus);
        
        
        //3. sense
        filter = "newcountvalue";
        IGoal sense;
        
         while(true){
             try{
                 sense = createGoal("sense");
                 sense.getParameter("sensor_name").setValue(sensorName);
                 sense.getParameter("filter").setValue(filter);
                 sense.getParameter("timeout").setValue(1000);
                 dispatchSubgoalAndWait(sense);
                 Perception p = (Perception)sense.getParameter("percept").getValue();
                 log("sensed value : " + p.getContent(0)  );

                IInternalEvent event = createInternalEvent("artifact_event");
                event.getParameter("label").setValue(p.getLabel());
                event.getParameter("perception").setValue(p);
                log(" Authomatically retrieved an artifact event perception. Now Dispatching JADEX Internal Event: " + event.getName() );
                dispatchInternalEvent(event);
                
             }catch(Exception e){
                 //log("ERROR in observing Counter !!");
                 //e.printStackTrace();
             }
        }
    }
    
    //@override
    public void aborted() {
        if(isAbortedOnSuccess())
        log(" GOAL ACHIEVED" );
        else log("GOAL FAILED");
        
        
        IGoal unfocus = createGoal("stop_focus");
        unfocus.getParameter("artifact_name").setValue(aName); 
        dispatchSubgoalAndWait(unfocus);
    }
    
    
    private void log(String s){
        System.out.println("["+getAgentName()+"] " + s);
    }
    
}
