/*
 * focusArtifactPlan.java
 *
 * Created on 5 dicembre 2007, 13.00
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */
package alice.c4jadex.examples;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    focusArtifactPlan
 *   focus the counter artifact and sense operation made by other agents upon it
 * @author Michele Piunti
 */
public class focusArtifactPlan extends Plan {
    
    /** Creates a new instance of focusArtifactPlan */
    public focusArtifactPlan() {
        
    }
    
    public void body(){
        // 1. MAKE artifact
        //  ArtifactId id = makeArtifact("count","alice.cartago.examples.basic.Count2")
        // "my-gui","alice.cartago.examples.basic.MyGUIArtifact"
        String aName = "count";
        
        IGoal lookup = createGoal("lookup");
        lookup.getParameter("artifact_name").setValue(aName);                
        dispatchSubgoalAndWait(lookup);
        ArtifactId aid = (ArtifactId)lookup.getParameter("aid").getValue();
        
        if(aid==null){
            System.out.println("Artifact not found, creating it...");
            String aTemplate = "alice.cartago.examples.basic.Count";
            ArtifactConfig aConfig = new ArtifactConfig();
            IGoal make = createGoal("make");
            make.getParameter("artifact_name").setValue(aName); 
            make.getParameter("artifact_template").setValue(aTemplate); 
            make.getParameter("artifact_config").setValue(aConfig); 
            dispatchSubgoalAndWait(make);
        }else
             log("Artifact found with id: " + aid);
            
//        ArtifactId aid = (ArtifactId)make.getParameter("aid").getValue();
//        System.err.println("create succeed: createded arifact: " + aName + " with arifact_Id -- " + aid.getId() );
        String sensorName = getAgentName()+"Sensor";
//        // 2. focus
//        
        IGoal focus = createGoal("focus");
        focus.getParameter("artifact_name").setValue(aName); 
        //focus.getParameter("sensor_name").setValue(sensorName); 
        dispatchSubgoalAndWait(focus);
        

        
        


             
     }
    
    
    private void log(String s){
        System.out.println("["+getAgentName()+"] " + s);
    }
       
}
    

