/*
 * makeArtifactPlan.java
 *
 * Created on 4 dicembre 2007, 15.40
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.examples;


import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    makeArtifactPlan
 * @author Michele Piunti
 */
public class makeArtifactPlan  extends Plan {
    ArtifactId aid;
    
    /** Creates a new instance of makeArtifactPlan */
    public makeArtifactPlan() {
    }
    
    
    public void body(){
        aid=null;
        String aName = "counter";
        String prop = "count";
        
        //1. look up artifact
        IGoal lookup = createGoal("lookup");
        lookup.getParameter("artifact_name").setValue(aName);                
        dispatchSubgoalAndWait(lookup);
        aid = (ArtifactId)lookup.getParameter("aid").getValue();
        
        if(aid==null){
        // 2. create artifact        
            String aTemplate = "alice.cartago.examples.basic.Count2";
            ArtifactConfig aConfig = new ArtifactConfig();
            IGoal make = createGoal("make");
            make.getParameter("artifact_name").setValue(aName); 
            make.getParameter("artifact_template").setValue(aTemplate); 
            make.getParameter("artifact_config").setValue(aConfig); 

            dispatchSubgoalAndWait(make);
            aid = (ArtifactId)make.getParameter("aid").getValue();
            System.out.println("["+getAgentName()+ "] Create succeed: createded arifact: " + aName + " with arifact_Id -- " + aid.getId() );
        }
        
        
        for(int j=0;j<10;j++){
            IGoal observeProp = createGoal("observe_property");
            observeProp.getParameter("artifact_name").setValue(aName);
            observeProp.getParameter("property").setValue(prop);
            IGoal use = createGoal("use");
            
            use.getParameter("artifact_name").setValue(aName);
            Op op = new Op("inc" );
            use.getParameter("op").setValue(op);         

            dispatchSubgoalAndWait(use);
            
            dispatchSubgoalAndWait(observeProp);

            ArtifactProperty aVal = (ArtifactProperty)observeProp.getParameter("value").getValue();
            Object[] contents = aVal.getContents();

            for(int i=0; i<contents.length;i++)
              System.out.println(j + ". is "+ contents[i]);
        }    
        

    }
    
}
