/*
 * senseGUIPlan.java
 *
 * Created on 5 dicembre 2007, 17.22
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.examples;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    senseGUIPlan
 * @author Michele Piunti
 */
public class senseGUIPlan extends Plan  {
        IGoal use,focus1,focus2,make,sense;
        Op op;   
        
    /** Creates a new instance of senseGUIPlan */
    public senseGUIPlan() {
    }
    
    public void body(){
        // 1. RETRIEVE artifact
        // "my-gui","alice.cartago.examples.basic.MyGUIArtifact"
        String aName = "my-gui";

        
        IGoal lookup = createGoal("lookup");
        lookup.getParameter("artifact_name").setValue(aName);                
        dispatchSubgoalAndWait(lookup);
        ArtifactId aid = (ArtifactId)lookup.getParameter("aid").getValue();
        
        if(aid==null){
            String aTemplate = "alice.cartago.examples.basic.MyGUIArtifact";
            ArtifactConfig aConfig = new ArtifactConfig();
            make = createGoal("make");
            make.getParameter("artifact_name").setValue(aName); 
            make.getParameter("artifact_template").setValue(aTemplate); 
            make.getParameter("artifact_config").setValue(aConfig); 
            dispatchSubgoalAndWait(make);
        }
//        ArtifactId aid = (ArtifactId)make.getParameter("aid").getValue();
//        System.err.println("create succeed: created artifact: " + aName + " with arifact_Id -- " + aid.getId() );
        
        String sensorName = "sensor-"+getAgentName();

        
        focus1 = createGoal("focus");
        focus1.getParameter("artifact_name").setValue(aName); 
        // by not indicating sensor name Internal Events are retrieved
        //focus.getParameter("sensor_name").setValue(sensorName); 
        //
        dispatchSubgoalAndWait(focus1);

        focus2 = createGoal("focus");
        focus2.getParameter("artifact_name").setValue(aName); 
        // by indicating a sensor name the events will be collected "also" in the sensor
        focus2.getParameter("sensor_name").setValue(sensorName); 
        //
        dispatchSubgoalAndWait(focus2);
        //4. sense
        String filter = "pressed|closed";
        int count = 0;
        
        while(true){
         try{
            sense = createGoal("sense");
            sense.getParameter("sensor_name").setValue(sensorName);
            sense.getParameter("filter").setValue(filter);
            sense.getParameter("timeout").setValue(5000);
            dispatchSubgoalAndWait(sense);
            
            Perception p = (Perception)sense.getParameter("percept").getValue();
            String type = p.getLabel();
            if (type.equals("closed")){
                System.err.println("GUI artifact has been closed" );
                break;
            } else if (type.equals("pressed")){
                System.err.println("Sensed a: " +type+ " Perception from : " + aName  );
                use  = createGoal("use");
                use.getParameter("artifact_name").setValue(aName);
                use.getParameter("sensor_name").setValue(sensorName);  

                op = new Op("setText","value "+(++count));
                use.getParameter("op").setValue(op);     
                dispatchSubgoalAndWait(use);

            } else {
                    System.err.println("unknown perception "+p);
            }
         }catch(Exception ex){
             System.err.println("[senseGUIPlan] No percepts from: " + aName );
             //ex.printStackTrace();
         }
        }

       
    }//body
    
}

    

