/*
 * switchingWorkspacesPlan.java
 *
 * Created on 21 febbraio 2008, 14.09
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.examples;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;


/**
 *    switchingWorkspacesPlan
 *   plays with workspaces and artifacts after a node is joined
 * @author Michele Piunti
 */
public class switchingWorkspacesPlan extends Plan {
    
    /** Creates a new instance of switchingWorkspacesPlan */
    public switchingWorkspacesPlan() {
    }
    
     public void body(){
         
         String WSname  = "mioWorkSpace";
         String sensorName  = "mySensor";
         
        //1. createa new WS
        IGoal createWS = createGoal("create_workspace");
        createWS.getParameter("workspace_name").setValue(WSname);                
        dispatchSubgoalAndWait(createWS);
        
        //2. switch WS        
        IGoal switchWS = createGoal("switch_workspace");
        switchWS.getParameter("workspace_name").setValue(WSname);                
        dispatchSubgoalAndWait(switchWS);
        
        //3. create Artifact in the new WS
        String aName = "new_counter";
        String aTemplate = "alice.cartago.examples.basic.Count";
        ArtifactConfig aConfig = new ArtifactConfig();
        IGoal make = createGoal("make");
        make.getParameter("artifact_name").setValue(aName); 
        make.getParameter("artifact_template").setValue(aTemplate); 
        make.getParameter("artifact_config").setValue(aConfig); 

        dispatchSubgoalAndWait(make);
        ArtifactId aid = (ArtifactId)make.getParameter("aid").getValue();
        
        log("create succeed: createded arifact: " + aName + 
                " with arifact_Id: " + aid.getId() +" in WORKSPACE:" + WSname);
        
        
        IGoal use = createGoal("use");
        use.getParameter("artifact_name").setValue(aName);
        use.getParameter("sensor_name").setValue(sensorName);  

        Op op = new Op("inc" );
        use.getParameter("op").setValue(op);         

        dispatchSubgoalAndWait(use);
        
        //4. quit WS
        IGoal quitWS = createGoal("quit_workspace");                      
        dispatchSubgoalAndWait(quitWS);
        
         
     }
     
    private void log(String s){
        System.out.println("["+getAgentName()+"] " + s);
    }
    
}
