/*
 * useCounterPlan.java
 *
 * Created on 4 dicembre 2007, 16.06
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.examples;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    useCounterPlan
 *  create a counter artifact, than makes operations on it and senses results
 * @author Michele Piunti
 */
public class useCounterPlan extends Plan{
    
    /** Creates a new instance of useCounterPlan */
    public useCounterPlan() {
        
    }
    
    public void body(){
        
        // 1. MAKE artifact
        //  ArtifactId id = makeArtifact("count","alice.cartago.examples.basic.Count2")
        // "my-gui","alice.cartago.examples.basic.MyGUIArtifact"
        String aName = "count";
        System.err.println(" created " + this);
        
        IGoal lookup = createGoal("lookup");
        lookup.getParameter("artifact_name").setValue(aName);                
        dispatchSubgoalAndWait(lookup);
        ArtifactId aid = (ArtifactId)lookup.getParameter("aid").getValue();
        
        if(aid ==null){
            String aTemplate = "alice.cartago.examples.basic.Count";
            ArtifactConfig aConfig = new ArtifactConfig();
            IGoal make = createGoal("make");
            make.getParameter("artifact_name").setValue(aName); 
            make.getParameter("artifact_template").setValue(aTemplate); 
            make.getParameter("artifact_config").setValue(aConfig); 
            dispatchSubgoalAndWait(make);
        }
//        ArtifactId aid = (ArtifactId)make.getParameter("aid").getValue();
//        System.err.println("create succeed: createded arifact: " + aName + " with arifact_Id -- " + aid.getId() );
//        String sensorName = getAgentName()+"Sensor";

        
        IGoal use;
//        waitFor(2000);
        
        // 2. use artifact
        for(int i=0; i<10; i++){
            waitFor(500);
            use = createGoal("use");
            use.getParameter("artifact_name").setValue(aName);
            //
            // By  not specifying a SENSOR NAME an Internal Artifact EVENT 
            // is automatically dispatched by the CARTAGO capability
            //
            //use.getParameter("sensor_name").setValue(sensorName);  
            //
            Op op = new Op("inc" );
            use.getParameter("op").setValue(op);         

            dispatchSubgoalAndWait(use);
        }
        
             
     }
    
}
