/*
 * gotoRoomPlan.java
 *
 * Created on 13 marzo 2008, 23.53
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.c4jadex.roomsworld.log;

import alice.c4jadex.bridge.*;
import alice.c4jadex.roomsworld.navigator.*;
import alice.cartago.*;
import alice.cartago.examples.roomsworld.location;
import jadex.runtime.*;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author michelepiunti
 */
public class gotoLogPlan extends Plan {
    
    private String sensorName,agentName;
    
    /** Creates a new instance of gotoRoomPlan */
    public gotoLogPlan() {
        sensorName = (String)getBeliefbase().getBelief("my_sensor").getFact();
        agentName = getAgentName();
    }
    
    public void body(){
        //waitFor(500);
        int target_room 
                = ((Integer)getBeliefbase().getBelief("target_room").getFact()).intValue();
        IRoomsWorldNavigator nav 
                = (IRoomsWorldNavigator)getBeliefbase().getBelief("navigator").getFact();
        location myL = (location)getBeliefbase().getBelief("my_loc").getFact();
        
        int myroom = nav.getRoom(myL);
        
        ArrayList<location> partialdests = nav.getChPath(myroom,target_room);        
        //ArrayList<location> dests = nav.getPath(myroom,target_room);
        
        Iterator<location> itPoint = partialdests.iterator();
        
        IGoal move;
        log(" going from room: *" +myroom + "*  to Room Door:  *" + target_room +"*");
			
	    while(itPoint.hasNext()){
            move = createGoal("GoToXY");
            move.getParameter("target_loc").setValue(itPoint.next());
            dispatchSubgoalAndWait(move);
        } 
        
        
        // need to update GOAL SUPPORTING BELIEFS
        // observe Log N and Watch to decide
	    
	    //log("updating Goal Supparting Beliefs");
        
        IGoal updateGSB = createGoal("observe_log");
        updateGSB.getParameter("target_room").setValue(target_room);
        dispatchSubgoalAndWait(updateGSB);
        
        //log("updated Goal Supparting Beliefs");
        
    }
    
    
    protected void log(String s){
        IGoal use = createGoal("use");
        
        use.getParameter("artifact_name").setValue("io");
        use.getParameter("sensor_name").setValue(sensorName);  
        String msg = "["+getAgentName()+"] " + s;
        Op op = new Op("print", msg );
        use.getParameter("op").setValue(op);         
        dispatchSubgoalAndWait(use);
 
        System.out.println(msg);
    }
    
}
