/*
 * gotoRoomPlan.java
 *
 * Created on 13 marzo 2008, 23.53
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.c4jadex.roomsworld.log;

import alice.c4jadex.bridge.*;
import alice.c4jadex.roomsworld.navigator.*;
import alice.cartago.*;
import alice.cartago.examples.roomsworld.location;
import jadex.runtime.*;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author michelepiunti
 */
public class gotoRoomPlan extends Plan {
    
    private String sensorName,agentName;
    
    /** Creates a new instance of gotoRoomPlan */
    public gotoRoomPlan() {
        sensorName = (String)getBeliefbase().getBelief("my_sensor").getFact();
        agentName = getAgentName();
    }
    
    public void body(){
        //waitFor(500);
        int target_room 
                = ((Integer)getBeliefbase().getBelief("target_room").getFact()).intValue();
        IRoomsWorldNavigator nav 
                = (IRoomsWorldNavigator)getBeliefbase().getBelief("navigator").getFact();
        location myL = (location)getBeliefbase().getBelief("my_loc").getFact();
        
        int myroom = nav.getRoom(myL);
        
        // let a note on LOG
        // before entering room
        
  	    IGoal writeLog = createGoal("write_log");
  	    writeLog.getParameter("target_log").setValue(target_room);
  	    dispatchSubgoalAndWait(writeLog);
        
        ArrayList<location> partialdests = nav.getPath(myroom,target_room);
        Iterator<location> itPoint = partialdests.iterator();
        
        IGoal move;
        log(" going from room: *" +myroom + "*  to room:  *" + target_room +"*");
			
	while(itPoint.hasNext()){
            move = createGoal("GoToXY");
            move.getParameter("target_loc").setValue(itPoint.next());
            dispatchSubgoalAndWait(move);
        } 
        
        startAtomic();
        myL = (location)getBeliefbase().getBelief("my_loc").getFact();
        getBeliefbase().getBelief("my_room").setFact(nav.getRoom(myL));
        endAtomic();
    }
    
    
    protected void log(String s){
        IGoal use = createGoal("use");
        
        use.getParameter("artifact_name").setValue("io");
        use.getParameter("sensor_name").setValue(sensorName);  
        String msg = "["+getAgentName()+"] " + s;
        Op op = new Op("print", msg );
        use.getParameter("op").setValue(op);         
        dispatchSubgoalAndWait(use);
 
        System.out.println(msg);
    }
    
}
