package alice.c4jadex.roomsworld.log;

import alice.cartago.Op;
import jadex.runtime.IGoal;
import jadex.runtime.Plan;
import alice.cartago.ArtifactProperty;

public class observeLogPlan extends Plan {
	
	private String sensorName,agentName;
	
    /** Creates a new instance of gotoRoomPlan */
    public observeLogPlan() {
        sensorName = (String)getBeliefbase().getBelief("my_sensor").getFact();
        agentName = getAgentName();
        log("observing artifacts to retrieve goal supporting beliefs");
    }

	@Override
	public void body() {
		
        // 1. retrieve actual time
        String aName = "watch";
        IGoal lookup = createGoal("lookup");
        lookup.getParameter("artifact_name").setValue(aName);                
        dispatchSubgoalAndWait(lookup);
		
		//log(" observing actualTime on Watch");		
		IGoal observeWatch = createGoal("observe_property");
		observeWatch.getParameter("artifact_name").setValue("watch");
		observeWatch.getParameter("property").setValue("sim_time");
		dispatchSubgoalAndWait(observeWatch);
		ArtifactProperty actualTime = ((ArtifactProperty)observeWatch.getParameter("value").getValue());
		long aTime = (Long)actualTime.getContent(0);
		log(" observed actualTime:"+ aTime + " on Watch");
		
		int N = ((Integer)getParameter("target_room").getValue()).intValue(); 
		// retrieve last time
		aName = "log"+N;
		lookup = createGoal("lookup");
        lookup.getParameter("artifact_name").setValue(aName);                
        dispatchSubgoalAndWait(lookup);
		
		//log(" observing lastnote on " + aName);
		IGoal observeLog = createGoal("observe_property");
		observeLog.getParameter("artifact_name").setValue(aName);
		observeLog.getParameter("property").setValue("lastnote");
		dispatchSubgoalAndWait(observeLog);
		ArtifactProperty lastTime = (ArtifactProperty)observeLog.getParameter("value").getValue();
		int lTime = (Integer)lastTime.getContent(0);
		log(" observed lastTime:" +  lTime + " on Log");
		
		startAtomic();
		  getBeliefbase().getBelief("tick_time").setFact(aTime);
		  getBeliefbase().getBelief("last_time").setFact(new Long(lTime));
		endAtomic();
		
		//getParameter("currentTime").setValue(actualTime); 
		//getParameter("lastTime").setValue(lastTime); 
		

	}
	
	
	
    protected void log(String s){
        IGoal use = createGoal("use");
        
        use.getParameter("artifact_name").setValue("io");
        use.getParameter("sensor_name").setValue(sensorName);  
        String msg = "["+getAgentName()+"] " + s;
        Op op = new Op("print", msg );
        use.getParameter("op").setValue(op);         
        //dispatchSubgoalAndWait(use);
 
        System.out.println(msg);
    }

}
