/*
 * cartagoEnvNavigator.java
 *
 * Created on 8 novembre 2007, 13.05
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.roomsworld.navigator;

import alice.cartago.examples.roomsworld.*;

import java.util.ArrayList;

/**
 *   utility class to navigate the environment across rooms
 * @author michelepiunti
 */
public class Rooms4 implements IRoomsWorldNavigator {


    final location envCenter, room1, room2, room3, room4, ch1, ch2, ch3, ch4;

    final ArrayList<location> f1t0 = new ArrayList<location>();
    final ArrayList<location> f2t0 = new ArrayList<location>();
    final ArrayList<location> f3t0 = new ArrayList<location>();
    final ArrayList<location> f4t0 = new ArrayList<location>();

    final ArrayList<location> f0t1 = new ArrayList<location>();
    final ArrayList<location> f0t2 = new ArrayList<location>();
    final ArrayList<location> f0t3 = new ArrayList<location>();
    final ArrayList<location> f0t4 = new ArrayList<location>();

    /** Creates a new instance of cartagoenvNavigator */
    public Rooms4() {

        envCenter = new location(0.5,0.5);
        room1 = new location(0.12, 0.62);
        room2 = new location(0.62, 0.88);
        room3 = new location(0.88, 0.38);
        room4 = new location(0.38, 0.12);

        ch1 = new location(0.25, 0.5);
        ch2 = new location(0.5, 0.75);
        ch3 = new location(0.75, 0.5);
        ch4 = new location(0.5, 0.25);

        f1t0.add(ch1);
        f1t0.add(envCenter);

        f2t0.add(ch2);
        f2t0.add(envCenter);

        f3t0.add(ch3);
        f2t0.add(envCenter);

        f4t0.add(ch4);
        f4t0.add(envCenter);

        f0t1.add(ch1);
        f0t1.add(room1);

        f0t2.add(ch2);
        f0t2.add(room2);

        f0t3.add(ch3);
        f0t3.add(room3);

        f0t4.add(ch4);
        f0t4.add(room4);


    }



    public ArrayList<location> getPath(int fromRoom, int toRoom)  {

        ArrayList<location> partialdests = new ArrayList<location>();
        ArrayList<location> empty = new ArrayList<location>();

        if(fromRoom==0){
            switch(toRoom){
                case(1): return f0t1;
                case(2): return f0t2;
                case(3): return f0t3;
                case(4): return f0t4;
                default: return empty;
            }
        }

        partialdests.clear();

        if(fromRoom==1){
            partialdests.addAll(f1t0);
            switch(toRoom){
                case(0): return partialdests;
                case(2): {
                    partialdests.addAll(f0t2);
                    return partialdests;
                }

                case(3): {
                    partialdests.addAll(f0t3);
                    return partialdests;
                }

                case(4): {
                    partialdests.addAll(f0t4);
                }
                default: return empty;
            }
        }

        partialdests.clear();

        if(fromRoom==2){
            partialdests.addAll(f2t0);
            switch(toRoom){
                case(0): {
                    return partialdests;
                }
                case(1): {
                    partialdests.addAll(f0t1);
                    return partialdests;
                }

                case(3): {
                    partialdests.addAll(f0t3);
                    return partialdests;
                }

                case(4): {
                    partialdests.addAll(f0t4);
                    return partialdests;
                }
                default: return empty;
            }
        }

        partialdests.clear();

        if(fromRoom==3){
            partialdests.addAll(f3t0);
            switch(toRoom){
                case(0): return partialdests;
                case(1): {
                    partialdests.addAll(f0t1);
                    return partialdests;
                }

                case(2): {
                    partialdests.addAll(f0t2);
                    return partialdests;
                }

                case(4): {
                    partialdests.addAll(f0t4);
                    return partialdests;
                }
                default: return empty;
            }
        }

        partialdests.clear();

        if(fromRoom==4){
            partialdests.addAll(f4t0);
            switch(toRoom){
                case(0): return partialdests;
                case(1): {
                    partialdests.addAll(f0t1);
                    return partialdests;
                }
                case(2): {
                    partialdests.addAll(f0t2);
                    return partialdests;
                }

                case(3): {
                    partialdests.addAll(f0t3);
                    return partialdests;
                }
                default: return empty;
            }
        }


        return empty;
    }

	public ArrayList<location> getChPath(int fromRoom, int toRoom)  {

		ArrayList<location> partialdests = new ArrayList<location>();

		if(fromRoom==0){
	            switch(toRoom) {
                         case(1): {
                                 partialdests.add(ch1);
                                         break;
                         }
                         case(2): {
                                 partialdests.add(ch2);
                                         break;
                         }
                         case(3): {
                                 partialdests.add(ch3);
                                         break;
                         }
                         case(4): {
                                 partialdests.add(ch4);
                                         break;
                         }
                         default: break;
		    }
		  return partialdests;
        }

		else if (fromRoom==toRoom)  {
			partialdests.clear();
			partialdests.add(goToChList(toRoom));
			return partialdests;
		}

		else{
		  partialdests.clear();
		  partialdests = getPath(fromRoom, 0);
		  partialdests.addAll(getChPath(0,toRoom));
		}
		return partialdests;
	}

    public location goToChList(int myRoom){
        switch(myRoom) {
            case(1): return ch1;
            case(2): return ch2;
            case(3): return ch3;
            case(4): return ch4;
            default: return envCenter;
        }

    }

    public int getRoom(location loc){
        int ret = 0;

        if(loc.x < 0.25) {
            if(loc.y >0.25) return 1;
            else return 4;
        }

        else if(loc.x < 0.75) {
            if(loc.y <0.25) return 4;
            if(loc.y >0.75) return 2;
            else return 0;
        }

        else if(loc.x > 0.75) {
            if(loc.y <0.75) return 3;
            else return 2;
        }

        return ret;

    }

}

