/*
 * CleanTrashPlan.java
 *
 * Created on 17 marzo 2008, 12.40
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.roomsworld.normal;

import alice.c4jadex.bridge.*;
import alice.c4jadex.roomsworld.navigator.*;
import alice.cartago.*;
import alice.cartago.examples.roomsworld.location;
import alice.cartago.examples.roomsworld.trash;
import alice.cartago.examples.roomsworld.Vision;
import alice.cartago.examples.roomsworld.trash;
import jadex.runtime.*;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *    CleanTrashPlan
 * @author Michele Piunti
 */
public class CleanTrashPlan extends Plan {
    
    private String agentName,sensorName;
    private int my_r;
    
    /** Creates a new instance of CleanTrashPlan */
    public CleanTrashPlan() {
        sensorName = (String)getBeliefbase().getBelief("my_sensor").getFact();
        agentName = getAgentName();
        my_r = (Integer)getBeliefbase().getBelief("my_room").getFact();
    }
    
    public void body(){
        
        trash to_clean = (trash)getParameter("trash").getValue(); 
        
        //1. go to target location
        location target= to_clean.getLocation();
        IGoal move = createGoal("GoToXY");
        move.getParameter("target_loc").setValue(target);
        dispatchSubgoalAndWait(move);
        
        //2. clean action
        IGoal clean = createGoal("use");
        IGoal sense = createGoal("sense");
        clean.getParameter("artifact_name").setValue("environment");
        clean.getParameter("sensor_name").setValue(sensorName);  
        Op op = new Op("clean", agentName, target.x, target.y );
        clean.getParameter("op").setValue(op);         
        

        sense.getParameter("sensor_name").setValue(sensorName);
        String filter = agentName+"cleaned|fail";
        sense.getParameter("filter").setValue(filter);
        sense.getParameter("timeout").setValue(100);

        dispatchSubgoalAndWait(clean);
        dispatchSubgoalAndWait(sense);
        
       Perception p = (Perception)sense.getParameter("percept").getValue();
       
       getBeliefbase().getBeliefSet("visited_rooms").addFact(my_r);
       
       if(p.getLabel().equals(agentName+"cleaned")) {
           removeBel("trashes", to_clean);
       } else {
           log(" Fail to clean trah : " + to_clean);
           getBeliefbase().getBeliefSet("trashes").removeFact(to_clean);
       }
       
       
    }
    
    private void removeBel(String belName, trash obj){
        trash[] bels = (trash[])getBeliefbase().getBeliefSet(belName).getFacts();
        
        for(int i=0;i<bels.length;i++){
            if(bels[i].getLocation().isEqual(obj.getLocation())){
                getBeliefbase().getBeliefSet(belName).removeFact(obj);
                return;
            }
                
        }    
    }
    
//    protected void log(String s){
//        System.out.println("["+getAgentName()+"] " + s);
//    }
    
    protected void log(String s){
        IGoal use = createGoal("use");
        
        use.getParameter("artifact_name").setValue("io");
        use.getParameter("sensor_name").setValue(sensorName);  
        String msg = "["+getAgentName()+"] " + s;
        Op op = new Op("print", msg );
        use.getParameter("op").setValue(op);         
        dispatchSubgoalAndWait(use);
 
        System.out.println(msg);
    }
    
}
