/*
 * GoToXYPlan.java
 *
 * Created on 14 marzo 2008, 0.15
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.c4jadex.roomsworld.normal;

import alice.c4jadex.bridge.*;
import alice.c4jadex.roomsworld.navigator.*;
import alice.cartago.*;
import alice.cartago.examples.roomsworld.location;
import jadex.runtime.*;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author michelepiunti
 */
public class GoToXYPlan extends Plan {
    
    private location myloc,target;
    private String agentName,sensorName;
    private  IRoomsWorldNavigator nav ;
    
    /** Creates a new instance of GoToXYPlan */
    public GoToXYPlan() {
        agentName = getAgentName();
        nav = (IRoomsWorldNavigator)getBeliefbase().getBelief("navigator").getFact();
    }
    
    public void body(){
        myloc = (location)getBeliefbase().getBelief("my_loc").getFact();
        sensorName = (String)getBeliefbase().getBelief("my_sensor").getFact();
        target = (location)getParameter("target").getValue(); 
        log("going to :" +target);
        goToLocation(target);
    }
    
    
    void goToLocation(location target)  {
        IGoal move,sense;
        
        while(!myloc.isEqual(target))   {
               // Ceck if location has changed in mean time.
               // calculate the new position offset.
               //double speed = 0.1;
           try {
               double d = myloc.getDistance(target);
               double r =  0.01;

               double dx = target.x-myloc.x;
               double dy = target.y-myloc.y;
               // When radius smaller than distance, just move a step.
               double rx = r<d ? r*dx/d : dx;
               double ry = r<d ? r*dy/d : dy;
               location newLoc = new location(myloc.x+rx, myloc.y+ry);
               
               move = createGoal("use");
               sense = createGoal("sense");
               
               // move(String agName, Object trg)   
                move.getParameter("artifact_name").setValue("environment");
                move.getParameter("sensor_name").setValue(sensorName);  
                Op op = new Op("move", agentName, newLoc );
                move.getParameter("op").setValue(op);         
                dispatchSubgoalAndWait(move);
		            
               //signalling ("movedin"+LOC, LOC);
                sense = createGoal("sense");
                sense.getParameter("sensor_name").setValue(sensorName);
                String filter = "movedin"+newLoc.signalling();
                sense.getParameter("filter").setValue(filter);
                sense.getParameter("timeout").setValue(100);
                dispatchSubgoalAndWait(sense);
                Perception p = (Perception)sense.getParameter("percept").getValue();
                myloc = (location)p.getContent(0); 
                getBeliefbase().getBelief("my_loc").setFact(myloc);
               //System.out.println("moved!");
 
              waitFor(200);  //wait for 0.2 seconds_ this is speed....
           } catch(Exception e){ }

          } //while
        
        //update my_room
        
        
     }

    protected void log(String s){
        System.out.println("["+getAgentName()+"] " + s);
    }
    
}
