/*
 * selectRoomPlan.java
 *
 * Created on 13 marzo 2008, 23.32
 *
 *  aliCE (c) 2007-2008
 *  Michele Piunti
 */

package alice.c4jadex.roomsworld.normal;

import alice.c4jadex.roomsworld.navigator.*;
import alice.cartago.examples.roomsworld.location;
import alice.cartago.Op;
//import alice.cartago.*;

import jadex.runtime.*;

import java.util.Random;

/**
 *
 * @author michelepiunti
 */
public class selectRoomPlan extends Plan {
    Random r;
    int NR;
    String sensorName,agentName;
    IRoomsWorldNavigator nav;
    location myL;
    int myroom;
    
    /** Creates a new instance of selectRoomPlan */
    public selectRoomPlan() {
        NR = ((Integer)getBeliefbase().getBelief("n_rooms").getFact()).intValue();
        sensorName = (String)getBeliefbase().getBelief("my_sensor").getFact();
        agentName = getAgentName();
    }
    
    
    public void body(){
        r = new Random(System.currentTimeMillis());        
        
        nav = (IRoomsWorldNavigator)getBeliefbase().getBelief("navigator").getFact();
        myL = (location)getBeliefbase().getBelief("my_loc").getFact();
        
        myroom = nav.getRoom(myL);
        
        startAtomic();
         getBeliefbase().getBelief("target_room").setFact(null);
         getBeliefbase().getBelief("target_room").setFact(selectRoom());
        endAtomic();        
    }
    
    protected int selectRoom(){
	
        int to_explore = 0;
        while((to_explore==0)||(to_explore==myroom))
            to_explore = r.nextInt(NR-1);
        
        if(getBeliefbase().getBeliefSet("visited_rooms").size()==NR)
        	getBeliefbase().getBeliefSet("visited_rooms").removeFacts();
        
        if(getBeliefbase().getBeliefSet("visited_rooms").containsFact(to_explore))
        	return selectRoom();
        else
        return to_explore+1;
    }
    
 
     protected void log(String s){
        IGoal use = createGoal("use");
        
        use.getParameter("artifact_name").setValue("io");
        use.getParameter("sensor_name").setValue(sensorName);  
        String msg = "["+getAgentName()+"] " + s;
        Op op = new Op("print", msg );
        use.getParameter("op").setValue(op);         
        dispatchSubgoalAndWait(use);
 
        System.out.println(msg);
    }
    
}
