/*
 * Rooms8.java
 *
 * Created on 20 novembre 2007, 16.21
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package roomsworld;

import alice.cartago.examples.roomsworld.*;

import java.util.ArrayList;

/**
 *    Rooms8
 * @author Michele Piunti
 */
public class Rooms8 implements IRoomsWorldNavigator{


    final location envCenter, room1, room2, room3, room4, room5, room6, room7, room8,
            ch1, ch2, ch3, ch4, ch5, ch6, ch7, ch8;

    final ArrayList<location> f1t0 = new ArrayList<location>();
    final ArrayList<location> f2t0 = new ArrayList<location>();
    final ArrayList<location> f3t0 = new ArrayList<location>();
    final ArrayList<location> f4t0 = new ArrayList<location>();
    final ArrayList<location> f5t0 = new ArrayList<location>();
    final ArrayList<location> f6t0 = new ArrayList<location>();
    final ArrayList<location> f7t0 = new ArrayList<location>();
    final ArrayList<location> f8t0 = new ArrayList<location>();

    final ArrayList<location> f0t1 = new ArrayList<location>();
    final ArrayList<location> f0t2 = new ArrayList<location>();
    final ArrayList<location> f0t3 = new ArrayList<location>();
    final ArrayList<location> f0t4 = new ArrayList<location>();
    final ArrayList<location> f0t5 = new ArrayList<location>();
    final ArrayList<location> f0t6 = new ArrayList<location>();
    final ArrayList<location> f0t7 = new ArrayList<location>();
    final ArrayList<location> f0t8 = new ArrayList<location>();

    /** Creates a new instance of cartagoenvNavigator */
    public Rooms8() {

        envCenter = new location(0.5,0.5);

        // rooms center
        room1 = new location(0.375, 0.88);
        room2 = new location(0.625, 0.88);
        room3 = new location(0.88, 0.625);
        room4 = new location(0.88, 0.375);
        room5 = new location(0.625, 0.12);
        room6 = new location(0.375, 0.12);
        room7 = new location(0.12, 0.375);
        room8 = new location(0.12, 0.625);

        // checklist locations
        ch1 = new location(0.375, 0.75);
        ch2 = new location(0.625, 0.75);
        ch3 = new location(0.75, 0.625);
        ch4 = new location(0.75, 0.375);
        ch5 = new location(0.625, 0.25);
        ch6 = new location(0.375, 0.25);
        ch7 = new location(0.25, 0.375);
        ch8 = new location(0.25, 0.625);

        // from * to 0
        f1t0.add(ch1);
        f1t0.add(envCenter);

        f2t0.add(ch2);
        f2t0.add(envCenter);

        f3t0.add(ch3);
        f3t0.add(envCenter);

        f4t0.add(ch4);
        f4t0.add(envCenter);

        f5t0.add(ch5);
        f5t0.add(envCenter);

        f6t0.add(ch6);
        f6t0.add(envCenter);

        f7t0.add(ch7);
        f7t0.add(envCenter);

        f8t0.add(ch8);
        f8t0.add(envCenter);

        //  from 0 to *
        f0t1.add(ch1);
        f0t1.add(room1);

        f0t2.add(ch2);
        f0t2.add(room2);

        f0t3.add(ch3);
        f0t3.add(room3);

        f0t4.add(ch4);
        f0t4.add(room4);

        f0t5.add(ch5);
        f0t5.add(room5);

        f0t6.add(ch6);
        f0t6.add(room6);

        f0t7.add(ch7);
        f0t7.add(room7);

        f0t8.add(ch8);
        f0t8.add(room8);


    }



    public ArrayList<location> getPath(int fromRoom, int toRoom)  {


        if(fromRoom==0){
           return getFrom0toX(toRoom);
        }

        ArrayList<location> partialdests = new ArrayList<location>();

        partialdests.clear();
        if(fromRoom==1){
            if(toRoom==1) return partialdests;
            partialdests.addAll(f1t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }

        partialdests.clear();
        if(fromRoom==2){
            if(toRoom==2) return partialdests;
            partialdests.addAll(f2t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }

        partialdests.clear();
        if(fromRoom==3){
            if(toRoom==3) return partialdests;
            partialdests.addAll(f3t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }
        partialdests.clear();
        if(fromRoom==4){
            if(toRoom==4) return partialdests;
            partialdests.addAll(f4t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }
        partialdests.clear();
        if(fromRoom==5){
            if(toRoom==5) return partialdests;
            partialdests.addAll(f5t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }
        partialdests.clear();
        if(fromRoom==6){
            if(toRoom==6) return partialdests;
            partialdests.addAll(f6t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }
        partialdests.clear();
        if(fromRoom==7){
            if(toRoom==7) return partialdests;
            partialdests.addAll(f7t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }
        partialdests.clear();
        if(fromRoom==8){
            if(toRoom==8) return partialdests;
            partialdests.addAll(f8t0);
            partialdests.addAll(getFrom0toX(toRoom));
            return partialdests;
        }

        return partialdests;
    }

	public ArrayList<location> getChPath(int fromRoom, int toRoom)  {

		ArrayList<location> partialdests = new ArrayList<location>();

		if(fromRoom==0){
	            switch(toRoom) {
                         case(1): {
                                 partialdests.add(ch1);
                                         break;
                         }
                         case(2): {
                                 partialdests.add(ch2);
                                         break;
                         }
                         case(3): {
                                 partialdests.add(ch3);
                                         break;
                         }
                         case(4): {
                                 partialdests.add(ch4);
                                         break;
                         }
                         case(5): {
                                 partialdests.add(ch5);
                                         break;
                         }
                         case(6): {
                                 partialdests.add(ch6);
                                         break;
                         }
                         case(7): {
                                 partialdests.add(ch7);
                                         break;
                         }
                         case(8): {
                                 partialdests.add(ch8);
                                         break;
                         }
                         default: break;
		    }
		  return partialdests;
              }

		else if (fromRoom==toRoom)  {
			partialdests.clear();
			partialdests.add(goToChList(toRoom));
			return partialdests;
		}

		else{
		  partialdests.clear();
		  partialdests = getPath(fromRoom, 0);
		  partialdests.addAll(getChPath(0,toRoom));
		}
		return partialdests;
	}

    public location goToChList(int myRoom){
        switch(myRoom) {
            case(1): return ch1;
            case(2): return ch2;
            case(3): return ch3;
            case(4): return ch4;
            case(5): return ch5;
            case(6): return ch6;
            case(7): return ch7;
            case(8): return ch8;
            default: return envCenter;
        }

    }

    public int getRoom(location loc){
        int ret = 0;

        if(loc.x < 0.25) {
            if(loc.y >0.5) return 8;
            else return 7;
        }

        else if(loc.x > 0.75) {
            if(loc.y <0.5) return 4;
            else return 3;
        }

        else if(loc.y > 0.75) {
            if(loc.x <0.5) return 1;
            else return 2;
        }

        else if(loc.y < 0.25) {
            if(loc.x <0.5) return 6;
            else return 5;
        }

        return ret;

    }

    private ArrayList<location> getFrom0toX(int x){

         switch(x){
                case(0): return new ArrayList<location>();
                case(1): {
                    return f0t1;
                }

                case(2): {
                    return f0t2;
                }

                case(3): {
                    return f0t3;
                }

                case(4): {
                    return f0t4;
                }
                case(5): {
                    return f0t5;
                }

                case(6): {
                    return f0t6;
                }

                case(7): {
                    return f0t7;
                }
                case(8): {
                    return f0t8;
                }
                default: return new ArrayList<location>();
            }
        }
    }



