// cleaner zero

/* Initial beliefs */
day(12).   // tresshold day length
myName(cleaner_msg2).
mySensor(mySensor).
myRoom(0).
targetRoom(0).



/* initial goal */
!join.

+!join <- 
     cartago.joinWorkspace("CartagoBDI","localhost:4010");
     .print("join *RoomsWorld* succeeded!");
     //cartago.lookupArtifact("console", Console);
	 ?myName(N);
	 ?mySensor(S);
     //cartago.use(Console, println( "joined Cartago Node" ));
	 cartago.lookupArtifact("environment", Env);
	 cartago.use(Env, join(N), S); 	 
	 cartago.sense(S, Percept, "joined");
     .print(N ," has joined in location: ", Percept);
	 cartago.use(Env, getNRooms, S); 	 
	 cartago.sense(S, n_rooms(Nr), "n_rooms");
	 .print(" RoomsWorld has n: ", Nr, " rooms");
	 +nRooms(Nr);
	 !!explore.
	  
+!explore 
   <- -targetRoom(_);      
      ?nRooms(N);
	  //select a room
      roomsworld.randomInt(N,X);   
	  // retrieve Watch Time
	  ?mySensor(S);
	  cartago.lookupArtifact("watch", W);
	  cartago.use(W, whatTime, S);  
	  cartago.sense(S, time(Wt), "time" );		  
	  !analizeMsg(X+1,Wt).

+!analizeMsg(N,Ct)	: not cleaned(N,Lt) | (cleaned(N,Lt) & day(D) & (D< Ct-Lt))
   <- -cleaned(N,_);
      !incCost(1);
      +targetRoom(N);
	  -targetRoom(_); 
      !go(N). 
   
+!analizeMsg(N,Ct)	 
   <- -cleaned(N,_);
	  +cleaned(N,Ct); 
	  !incCost(1);
      !explore.
	  
+!go(N): not myRoom(N)
   <- .print("going to ",N," room");   
      ?myRoom(MR);
	  roomsworld.goTo(MR, checklist(N));
	  roomsworld.goTo(MR, room(N)); 
	  -targetRoom(_);   
  	  -myRoom(_);
	  +myRoom(N);
	  //cartago.lookup_artifact("Console", Console);
	  //cartago.use(Console, println( "reached room: ", N )); 
	  .wait(2000); //simulating eistemic actions within the room
	  roomsworld.epistemicAction(N);	 
	  //?trash(N,_,_);
	  !!clean(N).

+!go(N) <- !!explore.

+!clean(N) : trash(N,X,Y)   
       <- ?trash(N,X,Y);
	      !cleanTrash(X,Y);		  
		  !!clean(N).	      
		  		 		  
+!clean(N) : not trash(N,_,_)
       <- //?wasteInRoom(N);
		  //-wasteInRoom(_);
		  ?mySensor(S);
		  cartago.lookupArtifact("watch", W);
	      cartago.use(W, whatTime, S);  
	      cartago.sense(S, time(Wt), "time" );		  
		  .broadcast(tell,cleaned(room(N, Wt)));
		  -cleaned(N,_);
		  +cleaned(N,Wt);
		  !incCost(1);		  
		  roomsworld.goTo(N, checklist(N));
		  !!explore.
	   
+!cleanTrash(X,Y)    
	   <- ?trash(N,X,Y);
	      roomsworld.goTo(X,Y);		  
		  ?mySensor(S);
		  ?myName(Na);		  
		  roomsworld.toString(Na, "cleaned|fail", Filter);
		  cartago.lookupArtifact("environment", E);
	      cartago.use(E, clean(Na, X, Y), S);
	      cartago.sense(S, Percept, Filter);
          //.print(" cleaned : ", Percept, " \n in ", N, " ", X, ";", Y);
		  -trash(N,X,Y)[source(_)].
		  
+cleaned(room(N,T))[source(_)] : true 
  <- -cleaned(room(N,_))[source(_)];
     -cleaned(N,_);
	 +cleaned(N,T);
	 !incCost(1);
     roomsworld.toString("received msg cleaned room:", N, "at time:", Str);
	 .print(Str, T);
     !log(Str, T).
	 
/*clean artifact events*/	 
+artifact_event(op_execution_completed(_),_)[source(_),op_name(_),op_id(_),when(_),source(_)]: true
  <- -artifact_event(op_execution_completed(_),_)[source(_),op_name(_),op_id(_),when(_),source(_)]. 
  
/* store a r-w cost */		  
+!incCost(C) : true
         <- cartago.lookupArtifact("stats", St);
	        cartago.use(St, incCost(C))./* store a r-w cost */		  

		  
/* send comments to roomsworld console */		  
+!log(M1) <- !log(M1, "", "").
+!log(M1,M2) <- !log(M1, M2, "").

+!log(M1,M2,M3) : not console(Io)
       <- cartago.lookupArtifact("io", Io);	
	      +console(Io);
		  ?myName(Agentname);
		  roomsworld.toString("[",Agentname,"]", T1);
		  roomsworld.toString(T1, M1, Md);
	      cartago.use(Io, print( Md, M2, M3 )).		  
+!log(M1,M2,M3) : console(Io)
       <- ?myName(Agentname);
	      roomsworld.toString("[",Agentname,"] ", T1);
		  roomsworld.toString(T1, M1, Md);
	      cartago.use(Io, print( Md, M2, M3 )).		
		  

