/* 
* cleaner zero
*  for each cleaned rooms queries the artifact timer and store a belief 
*  indicating the timestemp of the achieved activity
*/

/* Initial beliefs */
day(6).   // tresshold day length
myName(cleaner_zero_4).
mySensor(mySensor).
myRoom(0).
targetRoom(0).


/* initial goal */
!join.

+!join <- 
     cartago.joinWorkspace("CartagoBDI","localhost:4010");
     .print("join *RoomsWorld* succeeded!");
     //cartago.lookup_artifact("console", Console);
	 ?myName(Name);
	 ?mySensor(S);
     //cartago.use(Console, println( "joined Cartago Node" ));
	 cartago.lookupArtifact("environment", Env);
	 cartago.use(Env, join(Name), S); 	 
	 cartago.sense(S, Percept, "joined");
     .print(Name ," has joined in location: ", Percept);
	 cartago.use(Env, getNRooms, S); 	 
	 cartago.sense(S, n_rooms(Nr), "n_rooms");
	 .print(" RoomsWorld has n: ", Nr, " rooms");
	 +nRooms(Nr);
	 !explore.

	  
+!explore
   <- -targetRoom(_);      
      ?nRooms(N);
	  ?mySensor(S);
      roomsworld.randomInt(N,X);    
	  .print(" going to explore room: ", X+1);
      +targetRoom(X+1);	
	  	  // retrieve Watch Time
	  cartago.lookupArtifact("watch", W);
	  cartago.use(W, whatTime, S);  
	  cartago.sense(S, time(Wt), "time" );		  
	  !analizeBel(X+1,Wt).

	  
+!analizeBel(N,Ct)	: not cleaned(N,Lt) | (cleaned(N,Lt) & day(D) & (D< Ct-Lt))
   <- -cleaned(N,_);
      +targetRoom(N);
	  !incCost(1);
	  !go(N).

+!analizeBel(N,Ct)	 
   <- !explore.
      
	  
+!go(N): not myRoom(N)
   <- .print("going to ",N," room");   
      ?myRoom(MR);
	  roomsworld.goTo(MR, checklist(N));
	  roomsworld.goTo(MR, room(N));  
	  -targetRoom(_);   
  	  -myRoom(_);
	  +myRoom(N);
	  //cartago.lookup_artifact("Console", Console);
	  //cartago.use(Console, println( "reached room: ", N ));
	  .wait(2000); //simulating eistemic actions within the room
	  roomsworld.epistemicAction(N);	  
	  //?trash(N,_,_);
	  !clean(N).

+!go(N) <- !explore.

+!clean(N) : trash(N,X,Y)   
       <- ?trash(N,X,Y);
	      !cleanTrash(X,Y);
		  !clean(N).
	      		  		 		  
+!clean(N) : not trash(N,_,_)
       <- ?mySensor(S);
		  cartago.lookupArtifact("watch", W);
	      cartago.use(W, whatTime, S);  
	      cartago.sense(S, time(Wt), "time" );	
		  -cleaned(N,_);
		  +cleaned(N,Wt);
		  !incCost(1);
		  roomsworld.goTo(N, checklist(N));
		  !explore.
	   
+!cleanTrash(X,Y)    
	   <- ?trash(N,X,Y);
	      roomsworld.goTo(X,Y);		  
		  ?mySensor(S);
		  ?myName(Na);		  
		  roomsworld.toString(Na, "cleaned|fail", Filter);
		  cartago.lookupArtifact("environment", E);
	      cartago.use(E, clean(Na, X, Y), S);
	      cartago.sense(S, Percept, Filter);
          .print(" cleaned : ", Percept, " \n in ", N, " ", X, ";", Y);
		  -trash(N,X,Y).
		  
/* store a r-w cost */		  
+!incCost(C) : true
         <- cartago.lookupArtifact("stats", St);
	        cartago.use(St, incCost(C)).
		  
/* send comments to roomsworld console */		  
+!log(M1) <- !log(M1, "", "").
+!log(M1,M2) <- !log(M1, M2, "").

+!log(M1,M2,M3) : not console(Io)
       <- cartago.lookupArtifact("io", Io);	
	      +console(Io);
		  ?myName(Agentname);
		  roomsworld.toString("[",Agentname,"]", T1);
		  roomsworld.toString(T1, M1, Md).
	      //cartago.use(Io, print( Md, M2, M3 )).		  
+!log(M1,M2,M3) : console(Io)
       <- ?myName(Agentname);
	      roomsworld.toString("[",Agentname,"] ", T1);
		  roomsworld.toString(T1, M1, Md).
	      //cartago.use(Io, print( Md, M2, M3 )).		
		  

