
package roomsworld;

import jason.JasonException;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;


/**
  <p>Internal action: <b><code>roomsworld.getCh(<i>N</i>, CH)</code></b>.
  
  <p>Description: unifies <i>CH</i> with the checklist ch<i>N</i>
  
  <p>Parameter:<ul>
  
  <li>- value (CH): the variable to receive the checklist name<br/>
  <li>- value (N): the checklist's ID<br/>
  </ul>
  
  </p>

*/
public class getCh extends DefaultInternalAction {
       
	
    @Override
    public Object execute(TransitionSystem ts, Unifier un, Term[] args) throws Exception {
        try {
			if (!args[0].isNumeric()) {
                throw new JasonException("The first argument of the internal action 'getCh' has to be numeric.");                
            }
            if (!args[1].isVar()) {
                throw new JasonException("The second argument of the internal action 'getCh' has to be variable.");                
            }
			String ch = "ch"+args[0];

            return un.unifies(args[1], new StringTermImpl(ch));
			
        } catch (ArrayIndexOutOfBoundsException e) {
            throw new JasonException("The internal action 'getCh' has not received the required argument.");
        } catch (Exception e) {
            throw new JasonException("Error in internal action 'getCh': " + e, e);
        }    
    }
}

