/*
 * focus.java
 *
 * Created on 5 dicembre 2007, 11.57
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *   with a focus  action over an artifact the agent perceives all the events coming from the artifact
 * @author Michele Piunti
 */
public class focus extends cartago_action {
    
    SensorId sid;
    ArtifactId  aid;
    
    /** Creates a new instance of focus */
    public focus() {
    }
    
    /**
     * the plan body
     */
    public void body(){
        
        // MY NAME and CONTEXT
        String agentName = getAgentName();        
        try{
            actx = getContext(agentName); 
            if (actx==null){
	       throw new Exception("Need to join a workspace.");
            }
        } catch(Exception ex){
            ex.printStackTrace();
        }
        ICartagoContext ctx = actx.getContext();
       
        // SENSOR ID sid
        String sensorName = "";
        sid = null;
	
        try{
            sensorName = (String)getParameter("sensor_name").getValue();                    
            if ((sensorName!=null)&&(!sensorName.equals(""))) {	
            	    sid = actx.getSensorId(sensorName); 		
					if (sid == null){
						sid = ctx.getSensor(sensorName);
					    actx.storeSensorId(sensorName, sid);
					}
			}
            
        } catch(Exception e){
           log("use: problems exploiting sensor");           
        }   
        
        // ARTIFACT ID aid
        String artifactName = (String)getParameter("artifact_name").getValue();
        aid = actx.getArtifactId(artifactName);        
        if(aid==null){
         try{
            ctx.use(ctx.getRegistryId(),new Op("lookupArtifact",artifactName), sid);
            Perception p = ctx.sense(sid,"lookup_succeeded|lookup_failed");
                if (p.getLabel().equals("lookup_succeeded")){
                        aid = (ArtifactId)p.getContent(0);
                        actx.storeArtifactId(aid);
                }
         }catch(Exception ex){
             System.err.println("Artifact :" + artifactName + " does not exist");
             //ex.printStackTrace();
             return;
         }
        }
                
        // EXECUTE FOCUS
        try {
			if (sid==null){
				ctx.focus(actx,aid,actx.getDefaultSensor());
			} else {
				ctx.focus(aid,sid);
			}
		} catch (Exception ex){
			ex.printStackTrace();
		} finally {
		}
        
        
        
        
    }//body
    
}
