/*
 * sense.java
 *
 * Created on 29 novembre 2007, 14.54
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;


/**
 *    sense
 * @author Michele Piunti
 */
public class sense extends cartago_action {
    
    SensorId sid;
    String filter;
    Integer timeout;
    
    
    /** Creates a new instance of sense */
    public sense() {
        sid=null;
    }
    
   /**
     * the plan body
     */
    public void body() {
        
                // AGENT NAME and CONTEXT
        final String agentName = getAgentName();        
        try{
            actx = getContext(agentName); 
            if (actx==null){
	       throw new Exception("Need to join a workspace for sensing Artifacts.");
            }
        } catch(Exception ex){
            ex.printStackTrace();
        }
        final ICartagoContext ctx = actx.getContext();
        
        // get SensorName, timeout and label to filter percepts
        try{
          filter = (String)getParameter("filter").getValue();
          timeout = (Integer)getParameter("timeout").getValue();
        } catch (Exception ex){
             log(" problem in resolving filter and/or timeout params");
             //ex.printStackTrace();             
        }
        
        String sensorName = null;
        try{
            sensorName = (String)getParameter("sensor_name").getValue();                    
            if ((sensorName!=null)||(!sensorName.equals(""))) {	
            	    sid = actx.getSensorId(sensorName); 		
					if (sid == null){
						sid = ctx.getSensor(sensorName);
					    actx.storeSensorId(sensorName, sid);
					}
			}
            
        } catch(Exception e){
           log("use: problems exploiting sensor");           
        }     
        
        // EXECUTE SENSE
        // Use a separate thread for blocking sense operation.
        // Sync result listener will stop the plan (but keep the agent running).
        // The plan will continue, when the result (Perception) is available.
        final SyncResultListener	listener	= new SyncResultListener();
        new Thread(new Runnable() {
        	public void run() {
		      try{
		        Perception p=null;
		        if (filter!=null){
					if (timeout > -1){
						p = ctx.sense(sid,filter,timeout);
					} else {
						p = ctx.sense(sid,filter,Integer.MAX_VALUE);
					}
				} else {
					if (timeout > -1){
						p = ctx.sense(sid,timeout);
					} else {
						p = ctx.sense(sid);
					}
				}
		            
		        listener.resultAvailable(p);
              } catch (NoPerceptionException ex) {
		          System.err.println("["+agentName+"] SENSE basic action: " +
		        	          		"No Perception for : " + filter);
                  listener.resultAvailable(null);
                                //listener.exceptionOccurred(ex);
                                //return;
		      } catch (Exception ex) {
		        	listener.resultAvailable(ex);
                                //listener.exceptionOccurred(ex);
                                //return;
		        }
        	}
        }).start();
        
        try{
            Perception p = (Perception)listener.waitForResult();        
               // FINALIZE
            if(p!=null) {
                getParameter("percept").setValue(p);        
            }

        }catch(Exception e){            
                getParameter("percept").setValue(new Perception(null,null));        
        }           
    
    }
    
}
