/*
 * use.java
 *
 * Created on 29 novembre 2007, 14.52
 *
 * by Michele Piunti
 * ISTC - CNR, Rome, Italy.
 * AliCe - DEIS - UniBO, Blogna-Cesena, Italy.
 */

package alice.c4jadex.bridge.actions;

import alice.c4jadex.bridge.*;
import alice.cartago.*;
import jadex.runtime.*;

/**
 *    use Artifact OPs
 * @author Michele Piunti
 */
public class use extends cartago_action {
    
    SensorId sid;
    ArtifactId  aid;
    
    /** Creates a new instance of use */
    public use() {
       sid = null;
       aid=null;
    }
    
   /**
     * the plan body
     */
    public void body(){
        
        // MY NAME and CONTEXT
        String agentName = getAgentName();        
        try{
            actx = getContext(agentName); 
            if (actx==null){
	       throw new Exception("Need to join a workspace.");
            }
        } catch(Exception ex){
            ex.printStackTrace();
        }
        final ICartagoContext ctx = actx.getContext();
        String sensorName = "";
        
        sid = null;

        try{
            sensorName = (String)getParameter("sensor_name").getValue();                    
            if ((sensorName!=null)&&(!sensorName.equals(""))) {	
            	    sid = actx.getSensorId(sensorName); 		
					if (sid == null){
						sid = ctx.getSensor(sensorName);
					    actx.storeSensorId(sensorName, sid);
					}
			}
            
        } catch(Exception e){
           log("use: problems exploiting sensor");           
        }       
	   
                
        // retrieve ARTIFACT  Id
        String artifactName = (String)getParameter("artifact_name").getValue();
        aid = actx.getArtifactId(artifactName);
        if(aid==null){
         try{
            ctx.use(ctx.getRegistryId(),new Op("lookupArtifact",artifactName), sid);
            Perception p = ctx.sense(sid,"lookup_succeeded|lookup_failed");
                if (p.getLabel().equals("lookup_succeeded")){
                        aid = (ArtifactId)p.getContent(0);
                        actx.storeArtifactId(aid);
                }
         }catch(Exception ex){
             System.err.println("Artifact :" + artifactName + " does not exist");
             ex.printStackTrace();
         }
        }
        
        // OPERATION
        final Op op = (Op)getParameter("op").getValue();
        
        //  TIMEOUT
        int timeout = -1;
        
        // EXECUTE
        try {
			if (sid == null) {
				log("no sensor provided, using default..");
				if (timeout == -1){
					ctx.use(actx, aid, op, actx.getDefaultSensor());
				} else {
					ctx.use(actx, aid, op , actx.getDefaultSensor(),timeout);
				}
			} else {
				if (timeout == -1){
					ctx.use(aid, op, sid);
				} else {
					ctx.use(aid, op, sid, timeout);
				}
			}
			//return true;
		} catch (OpRequestTimeoutException ex) {
			//return false;
		} catch (Exception ex) {
			log("use(" + aid + "." + op + ") failed with: " + ex);
			// ex.printStackTrace();
			// return false;
		}	
                    

    }
    
}
