/* 
* cleaner log_2
*  for each cleaned rooms queries the artifact timer and store a belief 
*  indicating the timestemp of the achieved activity
*  exploits checklists to know whether a room has been cleaned by other agents
*  @author mpiunti
*/

/* Initial beliefs */
day(6).   // tresshold day length
myName(cleaner_log_2).
mySensor(mySensor).
myRoom(0).
targetRoom(0).
targetCh(0).

/* Business Beliefs: */
// trash(X,Y)
// loc(my, X,Y)
// room(my,X)
// room(target,X)

/* RELEVANT BELIREF SET */ 
// cleaned(n , t )

/* Artifact Beliefs: */
//artifactBel(name, id)

/* Initial goal */
!join.




/* Plans */
+!join 
   <- cartago.joinWorkspace("CartagoBDI","localhost:4010");	  
      // find artifact ids
      !locate_artifacts;
      .print("join *RoomsWorld* succeeded!");
	  ?myName(N);
	  ?mySensor(S);     	  
	  !log(" Hello Wolrd! ");
	  ?artifactBel(environment, Env);
	  cartago.use(Env, join(N), S); 	 
	  cartago.sense(S, Percept, "joined");
      .print(N ," has joined in location: ", Percept);
	  cartago.use(Env, getNRooms, S); 	 
	  cartago.sense(S, n_rooms(Nr), "n_rooms");
	  .print(" RoomsWorld has n: ", Nr, " rooms");
	  +nRooms(Nr);
	  !explore.

+!locate_artifacts
   <- cartago.lookupArtifact("environment", Env);
	  +artifactBel(environment, Env);
	  cartago.lookupArtifact("watch", W);
	  +artifactBel(watch, W);
	  cartago.lookupArtifact("stats", St);
	  +artifactBel(stats, St);
	  cartago.lookupArtifact("io", Io);	
	  +artifactBel(console, Io).
	  
+!explore
   <- -targetCh(_);
      ?nRooms(N);
	  ?mySensor(S); 
      roomsworld.randomInt(N,X);
	  .print(" going to read LOG: ", X+1);
      +targetCh(X+1);
	  	  // retrieve Watch Time
	  ?artifactBel(watch, W);
	  cartago.use(W, whatTime, S);  
	  cartago.sense(S, time(Wt), "time" );		  
	  !analizeMsg(X+1,Wt).

	  
+!analizeMsg(N,Ct)	: not cleaned(N,Lt) | (cleaned(N,Lt) & day(D) & (D< Ct-Lt))
   <- -cleaned(N,_);
      -targetRoom(_);
      +targetRoom(N);
	  !incCost(1);
	  !observeLog(N).

+!analizeMsg(N,Ct)	 
   <- !explore.

+!observeLog(N)	
   <- ?targetCh(N);
      ?myRoom(MR);
      roomsworld.goTo(MR, checklist(N));
	  -targetCh(N);
	  //retrieve my name and my sensor name as a initial beliefs 
	  ?myName(M);  
	  ?mySensor(S);
	  // read Checklist
	  roomsworld.toString("log", N, LOG ); //LOG = "log"+N;
	  // read checklist's note
	  cartago.lookupArtifact(LOG, LogID);
	  cartago.use(LogID, readLastNote, S);	
	  cartago.sense(S, last_note(Ln), "last_note");	  
	  // read watch	  
	  ?artifactBel(watch, W);
	  cartago.use(W, whatTime, S);  
	  cartago.sense(S, time(Wt), "time");
	  !log("retrieved WATCH TIME: ", Wt);
	  !log("retrieved LOG TIME: ", Ln);
	  !decide(N, Wt, Ln).
	  
/** 
* deliberation is here 
* embedded in transaction process 
* and written in the following plans 
*/
+!decide(N, CurrentTime, LastTime)
   : (day(D) & (D< CurrentTime-LastTime)) |
     (LastTime=0)
   <- !log("DECIDE TO ENTER! and let note on LOG");	 
	      roomsworld.toString("log", N, LOG ); //LOG = "log"+N;   //CH = "ch"+N;
	  ?mySensor(S);
	  cartago.lookupArtifact(LOG, LogID);
	  cartago.use(LogID, putNote(CurrentTime), S);	
	  !log("let note:", CurrentTime);
      !go(N).
   
+!decide(N, CurrentTime, LastTime)
   <- !log("I'VE RECONSIDERED MY INTENTIONS: EXPLORING!") ;
	  -cleaned(N,_);
	  +cleaned(N,LastTime);
	  !incCost(1);
	  -targetRoom(_);
      !explore. 
 
/*
* Basic Actions
*/
+!go(N): not myRoom(N)
   <- .print("Enter in room ", N);   
      ?myRoom(MR);
	  roomsworld.goTo(MR, room(N));  
	  -targetRoom(_);   
  	  -myRoom(_);
	  +myRoom(N);
	  //cartago.lookup_artifact("Console", Console);
	  //cartago.use(Console, println( "reached room: ", N ));
	  .wait(2000); //simulating eistemic actions within the room
	  roomsworld.epistemicAction(N);	  
	  //?trash(N,_,_);
	  !clean(N).

+!go(N) <- !explore.

+!clean(N) : trash(N,X,Y)   
       <- roomsworld.goTo(X,Y);	
	      !cleanTrash(X,Y);
		  ?mySensor(S);
		  !clean(N).
	      
+!clean(N) : not trash(N,_,_) 
       <- roomsworld.goTo(N, checklist(N));
		  //?myName(M);
		  ?mySensor(S);
		  ?artifactBel(watch, W);
	      cartago.use(W, whatTime, S);  
	      cartago.sense(S, time(Wt), "time" );
		  //roomsworld.getCh(N, CH);       //CH = "ch"+N;
	      //cartago.lookupArtifact(CH, Chid);
	      //cartago.use(Chid, putNote(Wt), S);	
		  //!log("let note:", Wt);
		  -cleaned(N,_);
		  +cleaned(N,Wt);
		  !incCost(1);
	      !explore.

	   
+!cleanTrash(X,Y)  : trash(N,X,Y)   
	   <- ?mySensor(S);
		  ?myName(Na);
		  roomsworld.toString(Na, "cleaned|fail", Filter);
		  ?artifactBel(environment, Env);
	      cartago.use(Env, clean(Na, X, Y), S);
	      cartago.sense(S, Percept, Filter, 1000);
          .print(" cleaned : ", Percept, " \n in ", N, " ", X, ";", Y);
		  -trash(N,_,_).
		  //.abolish(trash(N,X,Y)[source(_)]).

+!cleanTrash(X,Y) : not trash(N,X,Y)  
       <- .print(" too late !").

/*clean artifact events*/	 
+artifact_event(op_execution_completed(_),_)[source(_),op_name(_),op_id(_),when(_),source(_)]: true
  <- -artifact_event(op_execution_completed(_),_)[source(_),op_name(_),op_id(_),when(_),source(_)]. 
  
/* store a r-w cost */		  
+!incCost(C) : true
         <- ?artifactBel(stats, St);
	        cartago.use(St, incCost(C)).	
		  
/* send comments to roomsworld console */		  
+!log(M1) <- !log(M1, "", "").
+!log(M1,M2) <- !log(M1, M2, "").

	  
+!log(M1,M2,M3) : artifactBel(console, Io)
       <- ?myName(Agentname);
	      roomsworld.toString("[",Agentname,"] ", T1);
		  roomsworld.toString(T1, M1, Md);
	      cartago.use(Io, print( Md, M2, M3 )).		
		  

